<?php
namespace Acme\SosMonBundle\Command;
 
use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Acme\SosMonBundle\Event\PackageEvent; 
 
class MailCheckCommand extends ContainerAwareCommand
{
    protected function configure()
    {
        $this->setName('sosmon:mailcheck_command')
            ->setDescription('Check mailbox for events')
            ->addArgument('ownid', InputArgument::OPTIONAL, 'Customer ID');
    }
 
    protected function execute(InputInterface $input, OutputInterface $output)
    {
		
		$em = $this->getContainer()->get('doctrine')->getManager();
		
		$stations = $em->getRepository('AcmeSosMonBundle:Station')->getList(137, 0);
		
        for ($i = 0; $i < 4; $i++) {
			$index = rand ( 0 , count($stations) - 1 );		
//			$em->getRepository('AcmeSosMonBundle:Raw')->rawPackage( $this->generateXML($stations[ $index ]['esn'], '0x00394497C9279AAA00') );
		
		    $this->getContainer()->get('event_dispatcher')->dispatch('acme.events.package', new PackageEvent( 
											$this->generateXML($stations[ $index ]['esn'], '0x00394497C9279AAA00') 
											));	
			
		}	
//		$em->getRepository('AcmeSosMonBundle:Raw')->rawPackage( $this->generateXML('0-10045', '0x00394497C9279AAA00') );		
		
    }
	
	protected function generateXML($esn, $payload)
	{
		return  '<!DOCTYPE stuMessages SYSTEM "http://cody.glpconnect.com/DTD/StuMessage_Rev6.dtd">
					<stuMessages timeStamp="08/04/2009 14:23:12 GMT" messageID="f5aa8de8c29010048209aa52732b1716">
					<stuMessage>
					<esn>'.$esn.'</esn>
					<unixTime>'.time().'</unixTime>
					<gps>N</gps>
					<payload length="9" source="pc" encoding="hex">'.$payload.'</payload>
					</stuMessage>
					</stuMessages>';	
	}
	
}