<?php

namespace Acme\SosMonBundle\Controller;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\Security\Core\SecurityContextInterface;
use Acme\SosMonBundle\Model\Resanswer;
use Acme\SosMonBundle\Model\Common;
use Acme\SosMonBundle\Form\Type\ChgpwdType;
use \DateTime;

class DefaultController extends Controller
{
    public function indexAction()
    {
		$usr= $this->get('security.context')->getToken()->getUser();

		if( $this->container->get('security.context')->isGranted('IS_AUTHENTICATED_FULLY') ){
		
			if ($usr->getChgpassword() == 1){
				$form = $this->createForm(new ChgpwdType(), array('newpassword' => '',
																  'retrypassword' => ''	));
				
				return $this->render('AcmeSosMonBundle:Security:chgpwd.html.twig', array(
					'form'  => $form->createView(), 
					'id'=> $usr->getId(),
				));			
			}
			else {
				return $this->render('AcmeSosMonBundle:Default:index.html.twig', 
						array('ownid' => $usr->getOwnid(),
							  'access'=> $usr->getAcclevel()));
			}
		}
		else {
			return $this->redirect($this->generateUrl('login'));
		}       
    }
	
    public function session_checkAction()
    {

		$usr= $this->get('security.context')->getToken()->getUser();
		if( $this->container->get('security.context')->isGranted('IS_AUTHENTICATED_FULLY') ){
			return new Response(Resanswer::getRetJSON((array)$usr, is_object($usr), 0));
		}
		else {
			return $this->redirect($this->generateUrl('login'));
		} 
    }	

/* display top menu
   access is limited for user property

*/	
    public function topmenuAction(Request $request)
    {
		$usr= $this->get('security.context')->getToken()->getUser();
		$error   = $request->getSession()->get(SecurityContextInterface::AUTHENTICATION_ERROR);
		$company = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Customer')->find( $usr->getOwnid() );
		
		if ($usr->getOwnid() == 0) {
			$view = 'AcmeSosMonBundle:Default:topmenu_admin.html.twig';	
		}
		else {
			$view = 'AcmeSosMonBundle:Default:topmenu1.html.twig';	
		}
        return $this->render($view, 			
				array('last_username' => $usr->getName(),
				  'error'         => $error,
				  'access'        => $usr->getOwnid(),
				  'useracc'       => $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:User')->getAccessAsArray( $usr->getAccword() ),
				  'username'      => $usr->getName(),
				  'companyid'     => (is_object($company)? $company->getOwnid() :0),
				  'company'       => (is_object($company)? $company->getName() :' System console '),	
				  'refresh_rate'  => (is_object($company)? $company->getRrate() * 60000 : 0), 				  
				  ));
    }

    public function mapAction(Request $request)
    {
		$usr= $this->get('security.context')->getToken()->getUser();
		$error = $request->getSession()->get(SecurityContextInterface::AUTHENTICATION_ERROR);
		$company = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Customer')->find( $usr->getOwnid() );
		
        return $this->render('AcmeSosMonBundle:Default:map.html.twig', 			
				array(  'access'        => 1,
						'x_center'      => $company->getDefLat(),
						'y_center'      => $company->getDefLong(),
						'date_from'		=> date("m/d/Y"),
						'date_to'		=> date("m/d/Y"),
						'icon1' => $this->container->get('templating.helper.assets')->getUrl('bundles/acmesosmon/images/icon'.$company->getMstype().'1.png'),
						'icon2' => $this->container->get('templating.helper.assets')->getUrl('bundles/acmesosmon/images/icon'.$company->getMstype().'2.png'),
						'icon3' => $this->container->get('templating.helper.assets')->getUrl('bundles/acmesosmon/images/icon'.$company->getMstype().'3.png'),						
				  ));
    }	
	
	public function markersAction()
	{
		$usr= $this->get('security.context')->getToken()->getUser();
		$company = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Customer')->find( $usr->getOwnid() );
		
		$markers = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Station')->getMarkersForStations( $usr->getId(), $company->getDefLong(),  $company->getDefLat());	
		return new Response(Resanswer::getRetJSON($markers, true, 0));
	}
	
	
    public function traceAction($stationid, $dt1, $dt2, Request $request)
    {
		$usr= $this->get('security.context')->getToken()->getUser();

		$company = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Customer')->find( $usr->getOwnid() );
		$ibuttonid   = -1;
		$keyholderid = -1;
		$status      = -1;
		$systems     = -1;
		$dt1         = Common::zfdate(str_replace(".", "/", $dt1), 'us','mysql');
		$dt2         = Common::zfdate(str_replace(".", "/", $dt2), 'us','mysql');

		$markers = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Event')->getMarkersForEvents( $usr->getId(), $systems, $stationid, $ibuttonid, $keyholderid, $status, $dt1, $dt2, $company->getDefLong(),  $company->getDefLat());	
		return new Response(Resanswer::getRetJSON($markers, true, 0));	
    }		
	
 	public function status_dataAction( $opt )
	{
		$list = Common::getUnitStatuses( 1, $opt );
		return new Response(json_encode($list));	
	} 	
	
	public function statusAction()
	{
		$usr= $this->get('security.context')->getToken()->getUser();
		
		return new Response(json_encode($this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Station')->getCurrentStatus( $usr->getId())));	
	}
	
	public function testmailAction($email)
	{	
		if ( $email != 'none' ) {
	
			$message = \Swift_Message::newInstance()
            ->setSubject('Test mail')
            ->setFrom('ikaurov@gmail.com')
            ->setTo( $email )
			->setBody(
				$this->renderView(
					'AcmeSosMonBundle:Emails:testemail.html.twig',
					array('name' => 'Guest')
				)
			)
			->setContentType("text/html");
		
			$resp = $this->get('mailer')->send($message);
			return new Response(Resanswer::getRetJSON($email, ($resp == 1 ), 0));
		}
		
		return new Response(Resanswer::getRetJSON(json_encode($var), false, 0));
	}
		
	
    public function generateAction($key)
    {
	// company
	$f = 1;
	
		$deflat  = 44;
		$deflong = -94;
		$ownid = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Customer')->saveEntity(  
							array( 'ownid'    => 0,
									'name'    => 'Test company:'.$key,
									'keys' 	  => 1,
									'prefix'  => $key,
									'sentry'  => 1,
									'deflat'  => $deflat,
									'deflong' => $deflong,
									'rrate'   => 10,
									'active'  => 1,
								));
								
	// user	
	$f++;
		$userid = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:User')->saveEntity(  
							array(  'userid'   => 0,
									'name'     => 'Test user',
									'login'    => $key.'_admin',
									'password' => '1',
									'phone'    => '111-222',
									'mobile'   => '333-444',
									'email'    => 'ex@ex.com',
									'active'   => 1,
									'accword'  => '22222222222',
									'ownid'    => $ownid,
									'acclevel' => 1,
								));
	// stations							
	for ($i = 0; $i < 5; $i++) {
		$f++;	
		$deflat  = 44+$i/100;
		$deflong = -94+$i/70;		
		$dt = Common::fmtDateTime(new DateTime());
		
		$stationid = $userid = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Station')->saveEntity(  array( 
				'id' 		=> 0,			
				'ownid'     => $ownid,
				'name' 		=> 'Station '.$i.'-'.$i*1000,	
				'location' 	=> 'Unknown',			
				'note' 		=> '',		
				'esn' 		=> '',
				'type'		=> 1,	
				'dstart' 	=> $dt,
				'status'	=> 1,
				'longitude' => $deflong,				
				'latitude' 	=> $deflat,	
				'charge'	=> 77,
				'dcharge' 	=> $dt,
				'devent' 	=> $dt,
								));
			$d1 = new DateTime();					
			for ($j = 0; $j < 20; $j++) {		
	$f++;			
				$this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Event')->saveEntity(  
					array( 
					'id' 			=> 0,			
					'ownid'    		=> $ownid,
					'stationid' 	=> $stationid,	
					'ibuttonid' 	=> -1,			
					'keyholderid' 	=> -1,
					'status'		=> 1,
					'longitude' 	=> $deflong - $j*0.001,				
					'latitude' 		=> $deflat  + $j*0.005,	
					'charge'		=> 76-$j,		
					'edata' 		=> 'XX',
					'dt' 			=> $d1->modify( '-'.$j.' day' ),
				));								
			}
	}	
								
		return new Response(Resanswer::getRetJSON($key, true, $f));
    }	

}
