<?php

namespace Acme\SosMonBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Acme\SosMonBundle\Form\Type\EventType;
use Acme\SosMonBundle\Model\Resanswer;
use Acme\SosMonBundle\Model\Common;

class EventsController extends Controller
{
	
/**
* events main screen: list of available events
* /index
* @return view
*/
    public function indexAction()
    {
		$usr= $this->get('security.context')->getToken()->getUser();	
		$access = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:User')->getSectionAccess( $usr->getAccword(), 'events');
/*		
		if ($access == 0) { // no access 
			return $this->render('AcmeSosMonBundle:Default:denied.html.twig', array(
				'message'  => 'User '. $usr->getName().' has no access to events information',
			));		
		}
		else {
		*/
			return $this->render('AcmeSosMonBundle:Event:events.html.twig', 
				array('access' => $access,
					  'date_from' => date("m/d/Y", strtotime( "-1 month" )),
					  'date_to'   => date("m/d/Y"),
					  )
			);
//		}
    }
	
/**
* list of events as array	
* /data
* @return json array 
*/
    public function dataAction( Request $request)
    {
		$usr= $this->get('security.context')->getToken()->getUser();	
		$access = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:User')->getSectionAccess( $usr->getAccword(), 'events');

		if ($access == 0) { // guest cannot see any users
			return new Response(json_encode(array()));
		}
		else {
	
			$var = $request->request->all();	

			$company = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Customer')->find( $usr->getOwnid() );
			$systemid   = isset($var['systemid'])? (int)$var['systemid'] : 0;
			$stationid   = isset($var['stationid'])? (int)$var['stationid'] : 0;
			$ibuttonid   = isset($var['ibuttonid'])? (int)$var['ibuttonid'] : 0;
			$keyholderid = isset($var['keyholderid'])? (int)$var['keyholderid'] : 0;
			$status      = isset($var['status'])? (int)$var['status'] : 0;
			$dt1         = isset($var['dt1'])? Common::zfdate($var['dt1'], 'us','mysql') : Common::zfdate(date("m/d/Y", strtotime( "-1 month" )), 'us','mysql');
			$dt2         = isset($var['dt2'])? Common::zfdate($var['dt2'], 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
			$rows        = isset($var['rows']) ?(int)$var['rows']:0;
			if (isset($var['firstpage'])) {
				$offset = 0;
			} 
			else {
				$offset      = isset($var['page']) ?((int)$var['page'] - 1) * $rows:0;
			}
			
			$list = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Event')->getList( $rows, $offset, $usr->getId(), $systemid, $stationid, $ibuttonid, $keyholderid, $status, $dt1, $dt2, $company->getDefLong(),  $company->getDefLat());	
			return new Response(json_encode($list));	
			
		}
    }	
/**
* alerts tab screen
*
*/	
    public function alertsAction(Request $request)
    {
		$usr= $this->get('security.context')->getToken()->getUser();
		$company = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Customer')->find( $usr->getOwnid() );
		
        return $this->render('AcmeSosMonBundle:Event:alerts.html.twig', 			
				array(  'x_center'      => $company->getDefLat(),
						'y_center'      => $company->getDefLong(),				
				  ));
    }	
/**
* alerts_data for user
*/	
    public function alerts_dataAction(Request $request)
    {
		$usr= $this->get('security.context')->getToken()->getUser();
		$acclvl = $usr->getAcclevel();
		
		$rep = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Event');
		$company = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Customer')->findEntity( $usr->getOwnid(), 0 );
		
		if ($acclvl != 3) {
			$rows = $rep->getAlerts($usr->getId(), date("m/d/Y", strtotime( "-7 day" )), date("m/d/Y") );
		}
		else {
			$rows = $rep->getAlertsForContact($usr->getAlertcontactid(), date("m/d/Y", strtotime( "-7 day" )), date("m/d/Y") );
		}
	
	
        return $this->render('AcmeSosMonBundle:Event:alerts_list.html.twig', 			
				array(  'alerts' => $rows['rows'],								
						'y_coor' => $company['deflat'],
						'x_coor' => $company['deflong'],
						'zoom'   => $rows['zoom'])						
				  );

    }	
/**
* notifies_data
* @param int $eventid

*/	
    public function notifies_dataAction( $id )
    {
		$usr= $this->get('security.context')->getToken()->getUser();
		$em = $this->getDoctrine()->getManager();
		$acclvl = $usr->getAcclevel();
		
		$event   = $em->getRepository('AcmeSosMonBundle:Event')->findEntity($id, $usr->getOwnid());
		$system  = $em->getRepository('AcmeSosMonBundle:Alertstations')->getLocation($event['stationid']);
		//$system  = $em->getRepository('AcmeSosMonBundle:Alertsystem')->findEntity(	$alertsys['id'], $usr->getOwnid() );

        return $this->render('AcmeSosMonBundle:Event:alert_event.html.twig', 						
				  array(
					'event'   => $event,
					'usrlvl'  => $acclvl,
					'station' => $em->getRepository('AcmeSosMonBundle:Station')->findEntity($event['stationid'], $usr->getOwnid()),
					'location'=> $system['name'],
					'notifs'  => $em->getRepository('AcmeSosMonBundle:Event')->getNotifies( $id, $usr->getOwnid() ) 					
				  ));	
/*	
        return $this->render('AcmeSosMonBundle:Event:alert_event.html.twig', 						
				  array(
					'event'   => '',
					'usrlvl'  => $acclvl,
					'station' => '',
					'location'=> $system['name'],
					'notifs'  => ''					
				  ));			  
*/				  
    }
	
/**
* notifies_data
* @param int $eventid

*/	
    public function notifications_eventAction( $id )
    {	
		return new Response(json_encode(
					$this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Notifications')->NotificationsForEvent($id)
					));				  
    }	
/**
* Add notification
* @param int $eventid
* @param int $contactid
* @param int $ntype
* @param int $success
*/	
	public function notify_addAction( $eventid, $contactid, $ntype, $success) 
	{	
	// case 1-3 are obsolete, i believe. Since these notifications are coming from package processing automatically 
		switch($ntype) {
			case 1:
				$this->get('call_registration')->regPhoneNotification($contactid, $eventid, $success);
				break;		
			case 2:
				$this->get('call_registration')->regSmsNotification($contactid, $eventid, $success);
				break;	
			case 3:
				$this->get('call_registration')->regEmailNotification($contactid, $eventid, $success);
				break;	
			case 4:
				$this->get('call_registration')->regCloseNotification($contactid, $eventid, $success);
				// manual confirmation of solved alert by user.
				$this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Event')->saveResponse($eventid, $contactid, $success);
				break;				
		}
		return new Response(Resanswer::getRetJSON('', true, 0));		
	}
	
/**
* excel file	
* /export
* @return json array 
*/
    public function exportAction( Request $request)
    {

		$usr= $this->get('security.context')->getToken()->getUser();
		$em = $this->getDoctrine()->getManager();
		$access = $em->getRepository('AcmeSosMonBundle:User')->getSectionAccess( $usr->getAccword(), 'events');

		if ($access == 0) { // guest cannot see any users
			return new Response(json_encode(array()));
		}
		else {
	
			$var = $request->request->all();	

			$stationid   = isset($var['stationid'])? (int)$var['stationid'] : 0;
			$ibuttonid   = isset($var['ibuttonid'])? (int)$var['ibuttonid'] : 0;
			$keyholderid = isset($var['keyholderid'])? (int)$var['keyholderid'] : 0;
			$status      = isset($var['status'])? (int)$var['status'] : 0;
			$dt1         = isset($var['dt1'])? Common::zfdate($var['dt1'], 'us','mysql') : Common::zfdate(date("m/d/Y", strtotime( "-1 month" )), 'us','mysql');
			$dt2         = isset($var['dt2'])? Common::zfdate($var['dt2'], 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');

		// export starts			
			$excel = $em->getRepository('AcmeSosMonBundle:Event')->exportList( 
				$this->get('phpexcel')->createPHPExcelObject(),
				$usr->getId(), $stationid, $ibuttonid, $keyholderid, $status, $dt1, $dt2);			
		
			$response = $this->get('ExcelProcessing')->excelOut( $excel, 'events');	
		
			return $response; 
		}		
    }

/**
* info station
* /entity
* @param int $id
* @return view
*/
	public function infoAction($id, Request $request)
    {
		$usr= $this->get('security.context')->getToken()->getUser();
		$em = $this->getDoctrine()->getManager();
		$entity = $em->getRepository('AcmeSosMonBundle:Event')->findEntity($id, 
											$this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Event')->find( $usr->getOwnid() ));
		$entity['iname'] = '< none >';
		$entity['kname'] = '< none >';
											
		if ($entity['ibuttonid'] > 0) {
			$ibutton = $em->getRepository('AcmeSosMonBundle:Ibutton')->findEntity($entity['ibuttonid'], $usr->getOwnid());
			$entity['iname'] =  ( isset($ibutton['key']) ) ? $ibutton['key'] : '';
		}
		
		if ($entity['keyholderid'] > 0) {
			$keyholder = $em->getRepository('AcmeSosMonBundle:Keyholder')->findEntity($entity['keyholderid'], $usr->getOwnid());
			$entity['kname'] =  ( isset($keyholder['lname']) ) ? $keyholder['lname'].' '.$keyholder['fname'] :'' ;	
		}		
											
		$station = $em->getRepository('AcmeSosMonBundle:Station')->findEntity($entity['stationid'], $usr->getOwnid());
		
		return $this->render('AcmeSosMonBundle:Event:event_ro.html.twig', array(
			'event' => array( 'name'	=> (isset( $station['name'])? $station['name']: '' ),
							  'esn' 	=> (isset( $station['esn']) ? $station['esn'] : '' ),
							  'dt'  	=> $entity['dt'],
							  'dms'  	=> str_replace('&deg;','`', Common::DecimalToDMS((float)$entity['latitude'], false).' '.Common::DecimalToDMS((float)$entity['longitude'], true)),
							  'status'	=> Common::getStatusName( $entity['status'] ),
							  'iname'	=> $entity['iname'],
							  'kname'	=> $entity['kname'],
							  'payload' => $entity['edata'],
							  'id'      => $entity['id'],
						),
			'notifications' => $em->getRepository('AcmeSosMonBundle:Notifications')->NotificationsForEvent($entity['id']),
		));
    }
	
/**
* create or edit event
* /entity
* @param int $id
* @return view
*/
	public function entityAction($id, Request $request)
    {
		$usr= $this->get('security.context')->getToken()->getUser();
		$em = $this->getDoctrine()->getManager();
		$access = $em->getRepository('AcmeSosMonBundle:User')->getSectionAccess( $usr->getAccword(), 'events');

		if ($access == 0) { // no access 
			return $this->render('AcmeSosMonBundle:Default:denied.html.twig', array(
				'message'  => 'User '. $usr->getName().' has no access to events information',
			));		
		}
		
		$entity = $em->getRepository('AcmeSosMonBundle:Event')->findEntity($id, $usr->getOwnid());
		$entity['access']     = $access;
		$entity['statuses']   = Common::getUnitStatuses();
		$entity['rawid']      = 0; // as far as manual never connected with raw message
		
		$form = $this->createForm(new EventType(), $entity);
				
		return $this->render('AcmeSosMonBundle:Event:event.html.twig', array(
			'form'   => $form->createView(), 
			'entity' => $entity,
			'dt'     => date("m/d/Y h:i:s")
		));
    }

/**
* save Event, manual event input branch
* /save
* @param int $id
* @return json array('id','message','success')
*/
	public function saveAction(Request $request)
	{
		if ($request->getMethod() == 'POST') {

			$usr= $this->get('security.context')->getToken()->getUser();
			$em = $this->getDoctrine()->getManager();			
			
			$access = $em->getRepository('AcmeSosMonBundle:User')->getSectionAccess( $usr->getAccword(), 'events');

			if ($access == 0) { // no access 
				return $this->render('AcmeSosMonBundle:Default:denied.html.twig', array(
					'message'  => 'User '. $usr->getName().' can not save event information',
				));		
			}
		
			$var = $request->request->all();		
			$params = $var['event'];
			$id = $em->getRepository('AcmeSosMonBundle:Event')->saveEntity( $params );
		
			if ((int)$params['latest'] == 1) {
				$station = $em->getRepository('AcmeSosMonBundle:Station')->findEntity((int)$params['stationid'], $usr->getOwnid() );
				$station['latitude']  = $params['latitude']; 
				$station['longitude'] = $params['longitude']; 
				$station['charge']    = $params['charge']; 
				$station['status']    = $params['status']; 
				$station['eventid']   = $id;
				
				$em->getRepository('AcmeSosMonBundle:Station')->saveEntity($station );				
			}
			
					
			return new Response(Resanswer::getRetJSON($params['dt'],$id > 0, $id));	
		}	
	}
	
	
	
/**
* delete Events 	
* /delete
* @param int $id
* @return json array('id','message','success')
	*/	
	public function deleteAction($id)
    {
		$usr= $this->get('security.context')->getToken()->getUser();
		$em = $this->getDoctrine()->getManager();		
		$access = $em->getRepository('AcmeSosMonBundle:User')->getSectionAccess( $usr->getAccword(), 'events');
		if ($access == 0) { // no access 
			return new Response(Resanswer::getRetJSON('User '. $usr->getName().' can not delete event',false, $id));
		}	
		
		$em->getRepository('AcmeSosMonBundle:Event')->deleteEntity($id );		
		return new Response(Resanswer::getRetJSON('',true, $id));
    }	

}
