<?php

namespace Acme\SosMonBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Acme\SosMonBundle\Model\Resanswer;
use Acme\SosMonBundle\Model\Import;


class ImportController extends Controller
{

	public function importAction()
	{
		$usr= $this->get('security.context')->getToken()->getUser();	
		$access = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:User')->getSectionAccess( $usr->getAccword(), 'stations');
		
		if ($access == 0) { // no access 
			return $this->render('AcmeSosMonBundle:Default:denied.html.twig', array(
				'message'  => 'User '. $usr->getName().' has no access to import',
			));		
		}
		else {
			return $this->render('AcmeSosMonBundle:Import:import.html.twig', 
				array('access' => $access)
			);
		}	
	}
	
	public function uploadAction( Request $request )
	{
		$usr= $this->get('security.context')->getToken()->getUser();	
		
		$var = $request->request->all();

		$type = (int)$var['cb_import'];
		if ($type > 0) {
			$protocol = array('count' => 0,
							  'errors'=> 0,
							 );
							 
			$message = '';				 
					
			$company = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Customer')->find( $usr->getOwnid());					
			$data = Import::csv_to_array( $_FILES["fb_import"]["tmp_name"] );
			foreach ($data as $row) {
				if ($type == 1) { 
					if ( (!isset($row['Alert'])) || (!isset($row['Station'])) || (!isset($row['ESN'])) || (!isset($row['Location'])) || (!isset($row['Note'])) ) {
						$result = array('success' => 0, 'message' => 'Columns "Alert","Station","ESN","Location","Note" must be present');
					}
					else {
						$row['latitude']  = $company->getDeflat();
						$row['longitude'] = $company->getDeflong();
						$row['Alert']     = (strlen(trim($row['Alert'])) == 0)   ? 'Default': $row['Alert'];
						$row['Station']   = (strlen(trim($row['Station'])) == 0) ? 'No name': $row['Station'];
						if (strlen(trim($row['ESN'])) == 0) {
							$result = array('success' => 0,
											'message' => 'Station '.$row['Station'].' has no ESN');
						}
						else {
							$result = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Station')->importData( $usr->getOwnid(), $row );
						}
					}
				}
				if ($type == 2)  {
					$result = array(
						'success' => 0, 
						'message' => ''
					);
					
					if ( (!isset($row['Key'])) || (!isset($row['First'])) || (!isset($row['Last'])) || (!isset($row['Phone'])) ) {
						$result['message'] = 'Columns "Key","First","Last","Phone" must be present';
					}
					else {
						$keyid = 0;
						$result['message'] = 'Information is missing';
						if (strlen(trim($row['Key'])) > 0) {
							
							$entity = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Ibutton')->findOneByKey( trim($row['Key']) );
						    if (!$entity ) {
						   
								$keyid = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Ibutton')->saveEntity(array( 
									'id'       => 0,
									'ownid'    => $usr->getOwnid(),
									'keyholderid' => 0,
									'key'      => $row['Key'],
									'active'   => 1,
								));
								$result['success'] = 1; 
								$result['message'] = '';
							}
							else {
								$keyid             = $entity->getId();
								$result['message'] = 'Key '.$row['Key'].' already is in the system';
							}
						}
						
						if ((strlen(trim($row['First'])) > 0)||(strlen(trim($row['Last'])) > 0)) {
						
							$entity = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Keyholder')->findOneBy(
										array(  'fname' => $row['First'], 
												'lname' => $row['Last'], 
												'phone' => $row['Phone']
										));
						
							if (!$entity ) {
								$this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Keyholder')->saveEntity(array( 
									'id'        => 0,		
									'ownid'     => $usr->getOwnid(),
									'fname'     => $row['First'],
									'lname'     => $row['Last'],
									'phone'     => $row['Phone'],
									'ibuttonid' => $keyid,
								));
								$result['success'] = 1;
								$result['message'] = '';
							}	
							else {
								$result['message'] = 'Key holder '.$row['First'].' '.$row['Last'].' already is in the system';
							}
						}				
					}
				}
					
				if ($result['success'] == 1) {
					$protocol['count']++;
				}
				else {
					$protocol['errors']++;
					$message .= $result['message'].'<br>';
				}
			}		
		}
		$message = '<div style="font-size:15px;">Upload complete. <br> Uploaded <div style="display:inline-block;font-weight:bolder; color:#0c0">'.$protocol['count'].'</div><br>Errors <div style="display:inline-block; font-weight:bolder; color:#c00">'.$protocol['errors'].'</div>:<br></div>'.$message;	
		
		return new Response($message);
	}

}