<?php

namespace Acme\SosMonBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Acme\SosMonBundle\Model\Resanswer;
use Acme\SosMonBundle\Model\Common;

class RawsController extends Controller
{
	
/**
* raws main screen: list of raw data
* /index
* @return view
*/
    public function indexAction()
    {
		return $this->render('AcmeSosMonBundle:Raw:raws.html.twig', 
				array('date_from' => date("m/d/Y"),
					  'date_to'   => date("m/d/Y"),
					  )
			);
    }
	
/**
* list of raw data as array	
* /data
* @return json array 
*/
    public function dataAction( Request $request)
    {
	
			$var = $request->request->all();	

			$dt1         = isset($var['dt1'])? Common::zfdate($var['dt1'], 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
			$dt2         = isset($var['dt2'])? Common::zfdate($var['dt2'], 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
			$success     = isset($var['success'])? (int) $var['success'] : 0;	
			$rows        = isset($var['rows']) ?(int)$var['rows']:0;
			if (isset($var['firstpage'])) {
				$offset = 0;
			} 
			else {
				$offset      = isset($var['page']) ?((int)$var['page'] - 1) * $rows : 0;
			}
			
			$list = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Raw')->getList( $rows, $offset, $dt1, $dt2, $success);	
			return new Response(json_encode($list));	
    }	
	
/**
* create or edit event
* /entity
* @param int $id
* @return view
*/
	public function entityAction($id)
    {
		
		$entity = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Raw')->findEntity($id);
		$entity['info'] = ($entity['success'] == 1? 'Success' : 'Fail');		
		return $this->render('AcmeSosMonBundle:Raw:raw.html.twig', array(
			'entity' => $entity,
		));
    }

}
