<?php
namespace Acme\SosMonBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Acme\SosMonBundle\Model\Resanswer;
use Acme\SosMonBundle\Model\Common;

class ReportsController extends Controller
{
	
/**
* events main screen: list of available events
* /summarypage
* @return view
*/
    public function summarypageAction($ownid, Request $request)
    {
		$usr= $this->get('security.context')->getToken()->getUser();	

		return $this->render('AcmeSosMonBundle:Reports:summary.html.twig', 
			array(  'ownid'     => $ownid,
					'date_from' => date("m/d/Y", strtotime( "-1 month" )),
					'date_to'   => date("m/d/Y"),	
					'values'    => $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Notifications')->getSummary( array( 'ownid' => $ownid, 
						        'locationid' => 0, 
								'dt1'        => date("m/d/Y", strtotime( "-1 month" )),
								'dt2'        => date("m/d/Y"))  )
				  )
		);
    }
	
/**
* summary report
* /summarypage_data
* @return json array 
*/
    public function summarypage_dataAction(Request $request)
    {	
		$var = $request->request->all();
		$ownid       = isset($var['ownid'])? $var['ownid'] : 0;
		$locationid  = isset($var['locationid'])? $var['locationid'] : 0;
		$dt1         = isset($var['dt1'])? Common::zfdate($var['dt1'], 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		$dt2         = iisset($var['dt2'])? Common::zfdate($var['dt2'], 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		
		return new Response( 
			json_encode( $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Notifications')->getSummary( array( 'ownid'      => $ownid, 
						        'locationid' => $locationid, 
								'dt1'        => $dt1,
								'dt2'        => $dt2)  ) )
			);
    }	
	
/**
* summary excel file	
* /summaryexport
* @return request output
*/
    public function summaryexportAction( $target, $ownid, $locationid, $dt1, $dt2, Request $request)
    {

		$dt1         = isset($dt1)? Common::zfdate($dt1, 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		$dt2         = isset($dt2)? Common::zfdate($dt2, 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		
		// export starts	
		$excel = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Notifications')->exportSummary( 
						 $this->get('phpexcel')->createPHPExcelObject(),
						 array( 'ownid'      => $ownid, 
						        'locationid' => $locationid, 
								'dt1'        => $dt1,
								'dt2'        => $dt2)
						);		
		
		$response = new Response();
		if ($target == 'excel') {
			$response = $this->get('ExcelProcessing')->excelOut( $excel, 'usage_summary');	
		}
		if ($target == 'pdf') {
			$response = $this->get('ExcelProcessing')->pdfOut( $excel, 'usage_summary');	
		}		

		return $response; 		
	}	

/**
* billing report 
* /billing
* @return view
*/
    public function billingAction($ownid)
    {
		$usr= $this->get('security.context')->getToken()->getUser();
		$em = $this->getDoctrine()->getManager();
		
		return $this->render('AcmeSosMonBundle:Reports:billing.html.twig',
				$em->getRepository('AcmeSosMonBundle:Notifications')->getBilling(
								array ('ownid' => $ownid,
								       'dt1'   => date("m/01/Y"),
									   'dt2'   => date("m/d/Y"))
									  )
				
				);
		/*		
			array('ownid' 	 => $ownid,
				'date_from'  => date("m/01/Y"),
				'date_to'    => date("m/d/Y"),
				'fixedcount' => $company->getFixedcount(),
				'fixedprice' => $company->getFixedprice(),
				'extraprice' => $company->getExtraprice(),
				'pingfixed'  => $billing['pingfixed'],
				'pingextra'  => $billing['pingextra'],
				'cost_fixed' => $billing['cost_fixed'],
				'cost_extra' => $billing['cost_extra'],
				'cost_total' => $billing['cost_fixed'][''],
				)
		);
		*/
    }
	
/**
* billing
* /billing_data
* @return json array 
*/
    public function billing_dataAction(Request $request)
    {
	
		$var = $request->request->all();
		$em = $this->getDoctrine()->getManager();
		
		$ownid       = isset($var['ownid'])? (int)$var['ownid'] : 0;			
		$dt1         = isset($var['dt1'])? Common::zfdate($var['dt1'], 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		$dt2         = isset($var['dt2'])? Common::zfdate($var['dt2'], 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		
		return new Response( 
			json_encode( $em->getRepository('AcmeSosMonBundle:Notifications')->getBilling(
						array(  'ownid'      => $ownid, 
								'dt1'        => $dt1,
								'dt2'        => $dt2)) )
			);
    }	

/**
* billing	
* /billingexport
* @return request output
*/
    public function billingexportAction( $target, $ownid, $dt1, $dt2, Request $request)
    {

		$dt1         = isset($dt1)? Common::zfdate($dt1, 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		$dt2         = isset($dt2)? Common::zfdate($dt2, 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		
		// export starts	
		$excel = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Notifications')->exportBilling( 
						 $this->get('phpexcel')->createPHPExcelObject(),
						 array( 'ownid'      => $ownid, 
								'dt1'        => $dt1,
								'dt2'        => $dt2)
						);
						
		$response = new Response();
		if ($target == 'excel') {
			$response = $this->get('ExcelProcessing')->excelOut( $excel, 'billing');	
		}
		if ($target == 'pdf') {
			$response = $this->get('ExcelProcessing')->pdfOut( $excel, 'billing');	
		}	

		return $response; 		
	}	
	
/**
* call log report 
* /calllog
* @return view
*/
    public function calllogAction($ownid)
    {
		$usr= $this->get('security.context')->getToken()->getUser();	

		return $this->render('AcmeSosMonBundle:Reports:calllog.html.twig', 
			array('ownid' 	  => $ownid,
				  'date_from' => date("m/d/Y", strtotime( "-1 month" )),
				  'date_to'   => date("m/d/Y"),			
				  )
		);
    }
	
/**
* call log data
* /calllog_data
* @return json array 
*/
    public function calllog_dataAction(Request $request)
    {
	
		$var = $request->request->all();
		$ownid       = isset($var['ownid'])? (int)$var['ownid'] : 0;
		$locationid  = isset($var['locationid'])? (int)$var['locationid'] : 0;
		$dt1         = isset($var['dt1'])? Common::zfdate($var['dt1'], 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		$dt2         = isset($var['dt2'])? Common::zfdate($var['dt2'], 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		
		return new Response( 
			json_encode( $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Notifications')->getCalllog( array( 'ownid'      => $ownid, 
						        'locationid' => $locationid, 
								'dt1'        => $dt1,
								'dt2'        => $dt2)  ) )
			);
    }	
	
/**
* summary excel file	
* /calllogexport
* @return request output
*/
    public function calllogexportAction( $target, $ownid, $locationid, $dt1, $dt2, Request $request)
    {

		$dt1         = isset($dt1)? Common::zfdate($dt1, 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		$dt2         = isset($dt2)? Common::zfdate($dt2, 'us','mysql') : Common::zfdate(date("m/d/Y"), 'us','mysql');
		
		// export starts	
		$excel = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Notifications')->exportCalllog( 
						 $this->get('phpexcel')->createPHPExcelObject(),
						 array( 'ownid'      => $ownid, 
						        'locationid' => $locationid, 
								'dt1'        => $dt1,
								'dt2'        => $dt2)
						);
						
		$response = new Response();
		if ($target == 'excel') {
			$response = $this->get('ExcelProcessing')->excelOut( $excel, 'call_log');	
		}
		if ($target == 'pdf') {
			$response = $this->get('ExcelProcessing')->pdfOut( $excel, 'call_log');	
		}	

		return $response; 		
	}	
/**
* summary excel file	
* /fullreportexport
* @return request output
*/
    public function fullreportexportAction($target)
    {
		$usr= $this->get('security.context')->getToken()->getUser();	
		
		// export starts	
		$excel = $this->getDoctrine()->getManager()->getRepository('AcmeSosMonBundle:Alertsystem')->getFullreportexport( 
						 $this->get('phpexcel')->createPHPExcelObject(),
						 array( 'ownid' => $usr->getOwnid() )
						);
						
		$response = new Response();
		if ($target == 'excel') {
			$response = $this->get('ExcelProcessing')->excelOut( $excel, 'full_report');	
		}
		if ($target == 'pdf') {
			$response = $this->get('ExcelProcessing')->pdfOut( $excel, 'full_report');	
		}

		return $response; 
	}	
}