<?php
namespace Acme\SosMonBundle\Entity;

use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\NoResultException;
use \DateTime;
use Acme\SosMonBundle\Model\Common;

class ActlogRepository extends EntityRepository 
{
	/**
	* Get all Actlog
	*
	* @return $res array
	*/
	public function getList($rows, $offset, $userid, $ownid, $dt1, $dt2)
	{	

		$stmt = $this->getEntityManager()->getConnection()->prepare('SELECT * FROM getActlogs(:ownid, :userid, :dt1, :dt2, :rows, :offset)');
		$stmt->bindValue('ownid', $ownid);		
		$stmt->bindValue('userid', $userid);	
		$stmt->bindValue('dt1', $dt1);
		$stmt->bindValue('dt2', $dt2);
		$stmt->bindValue('rows', $rows);
		$stmt->bindValue('offset', $offset);
		$stmt->execute();
		$rows = $stmt->fetchAll();	
				 
		$res = array();
		$total = 0;
		
		foreach ($rows as $row) {
			$total = (int)$row['total'];
			$res[] = array(
				'id' 		=> (int)$row['id'],		
				'ownid' 	=> (int)$row['ownid'],	
				'userid' 	=> (int)$row['userid'],				
				'dt' 		=> $row['dt'],			
				'customer'  => $row['customer'],				
				'err'		=> (int)$row['err'],
				'cmd' 		=> $row['cmd'],	
				'uname' 	=> $row['uname'],
			);
		}
		return array("total" => $total, 
					 "rows"  => $res);
	}	
	
	/**
	* Save Actlog
	*
	* @param array $var  

	* @return entity id
	*/
	public function saveEntity( $var )
	{

		$entity = new Actlog();
		
		$entity->setOwnid(    $var['ownid'] );
		$entity->setUserid(   $var['userid'] );
		$entity->setErr(      $var['err'] );
		$entity->setCmd(      $var['cmd'] );
		$entity->setEntity(   $var['entity'] );
		$entity->setEntityid( $var['entityid'] );
		$entity->setDt( new DateTime);
					
		$em = $this->getEntityManager();				
		$em->persist($entity);
		$em->flush();
		return $entity->getId();			
	}
}

