<?php
namespace Acme\SosMonBundle\Entity;

use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\NoResultException;
use \DateTime;
use Acme\SosMonBundle\Model\Common;

class AlertstationsRepository extends EntityRepository 
{

	
	public function countStations( $alertsystemid )
	{	
		$asystems = $this->findByAlertsystemid( $alertsystemid );
			
		return count($asystems);
	}	
	
	public function getLocation( $stationid) {
		$list = $this->findOneBy(array('stationid' => $stationid));

		$res = array('id' => 0,
					 'name'=> '');
		
		if ($list) {
			$res[ 'id' ]   = $list->getAlertsystemid();
			$as            = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Alertsystem')->findOneBy(array('id' => $res[ 'id' ] ));	
			$station       = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Station')->findEntity( $stationid, 0 );	
			$res[ 'name' ] = $as->getName().' '.$station['name'];
		}
		return $res;
	}
	
	public function setLocation( $stationid, $asystems) {
	
		$this->deleteForStation( $stationid );
		
		if ($asystems > 0) {
			$this->saveEntity( array (  'stationid'     => $stationid,
										'alertsystemid' => $asystems) );		
		}
	}	
	
	
	public function assignKeyForLocation( $ibutton, $alertsystemid )
	{	
		$stations = $this->findByAlertsystemid( $alertsystemid );
		$count = 0;
		foreach($stations as $station) {
			$rows = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Keystations')->getKeystations($ibutton, $station->getStationid() );
			if (count($rows) == 0) {
				$this->getEntityManager()->getRepository('AcmeSosMonBundle:Keystations')->saveEntity( array (   'stationid' => $station->getStationid(),
																												'ibuttonid' => $ibutton) );
				$count++;
			}
		}
			
		return $count;
	}	
	
	
	/**
	* Assign systems to station
	*
	* @return $res array
	*/
	public function assignSystems( $id, $asystems )
	{	
		$this->deleteForStation( $id );
		
		foreach($asystems as $row) {
			$this->saveEntity( array (  'stationid'     => $id,
										'alertsystemid' => $row) );
		}	
		return 1;
	}

	/**
	* Save Alertstation
	*
	* @param array $var  

	* @return entity id
	*/	
	public function saveEntity( $var )
	{
		$entity = new Alertstations();
		
		$entity->setStationid(     $var['stationid'] );
		$entity->setAlertsystemid( $var['alertsystemid'] );
					
		$em = $this->getEntityManager();				
		$em->persist($entity);
		$em->flush();
		return $entity->getId();			
	}

	/**
	* Delete for station
	*
	* @param int $id
	* @return 1
	**/
	public function deleteForStation( $id )
	{		
		$this->getEntityManager()->getConnection()->executeUpdate('delete from alertstations where stationid = :id', 
			array('id' => $id)
		);			 
		return 1;
	}
}