<?php
namespace Acme\SosMonBundle\Entity;

use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\NoResultException;

class AlertsystemRepository extends EntityRepository 
{

	/**
	* Get all Alertsystems
	*
	* @return $res array
	*/
	public function getList( $ownid, $opt=0 )
	{	
		$systems = $this->findBy(array('ownid' => $ownid, 'deleted' => 0), array('name' => 'ASC'));
		$res = array();
		if ($opt == 1) {
			$res[] = array(
				'id' 		 => 0,		
				'name' 		 => 'ALL',	
			);		
		}	
		if ($opt == 2) {
			$res[] = array(
				'id' 		 => 0,		
				'name' 		 => 'NONE',	
			);		
		}		
		foreach ($systems as $row) {
			$res[] = array(
				'id' 		 => $row->getId(),		
				'name' 		 => $row->getName(),	
			);
		}		
		return $res;
	}	
	
	/**
	* Get all Alertsystems
	*
	* @return $res array
	*/
	public function getListCombo( $ownid, $opt=0 )
	{	
		$systems = $this->findBy(array('ownid' => $ownid, 'deleted' => 0), array('name' => 'ASC'));
		$res = array();
		if ($opt == 2) {
			$res[0] = 'NONE';			
		}		
		foreach ($systems as $row) {
			$res[ $row->getId() ] = $row->getName();
		}		
		return $res;
	}	
	
	/**
	* Get all Alertsystems
	*
	* @return $res array

	public function getListForCombo( $ownid, $opt )
	{	
		$systems = $this->findBy(array('ownid' => $ownid, 'deleted' => 0), array('name' => 'ASC'));
		$res = array();
		
		if ($opt == 1) {
			$res[] = array(
				'id' 		 => 0,		
				'name' 		 => 'ALL',	
			);		
		}
		
		foreach ($systems as $row) {
			$res[] = array(
				'id' 		 => $row->getId(),		
				'name' 		 => $row->getName(),	
			);
		}
		
		return $res;
	}	
	*/

	/**
	* Get entity SosMon alertsystem
	*
	* @param int $id
	* @param int $ownid
	* @return entity $entity
	*/			
	public function findEntity($id, $ownid)
	{
		$entity = $this->find($id);	
		if (!$entity) {
			$entity = new Alertsystem(); 
			$entity->setOwnid( $ownid );			
		}
		
		return array(	'id' 		=> (int)$entity->getId(),			
						'ownid' 	=> (int)$entity->getOwnid(),			
						'name' 		=> $entity->getName(),
					);		
	}
	
	/**
	* Save Alertsystem
	*
	* @param array $var  
	* @return entity id
	*/
	public function saveEntity( $var )
	{
		$entity = $this->find((int)$var['id']);	
		if (!$entity) {
			$entity = new Alertsystem();
		}
	
		$entity->setOwnid(   (int)$var['ownid'] ); 
		$entity->setName(     $var['name'] );		

				
		$em = $this->getEntityManager();				
		$em->persist($entity);
		$em->flush();	
		$id = $entity->getId();	
		
		return $id;			
	}		
		
	/**
	* Delete alertsystem
	*
	* @param int $id
	* @return 1
	**/
	/**
	* Delete contact
	*
	* @param int $id
	* @return 1
	**/
	public function deleteEntity( $id )
	{	
	
		$entity = $this->find( $id );	
		if ($entity) {
			$em = $this->getEntityManager();						
			if ( $this->canDelete( $entity )) {
				$em->remove($entity);
			}
			else {
				$entity->setDeleted( 1 ); 
				$em->persist($entity);				
			}
			$em->flush();		
	    }
		return $entity;
	}	
	
	/**
	* Check if entity can be deleted or not
	*
	* @param $ntity
	* @return bool
	**/
	public function canDelete( $entity )
	{	
		$flag = false;
		return $flag;
	}	
	
	public function getFullreportexport( $phpExcelObject,  $params )
	{
		$ownid = (int)$params['ownid'];
		$res = $this->findBy(array('ownid' => $ownid,  'deleted' => 0));
		
		$phpExcelObject->getProperties()->setCreator("SosMon datafile")
			->setTitle("MS Excel spreadsheet");		
	
		$sheet = $phpExcelObject->setActiveSheetIndex(0);

		$styleArray = array(
			'borders' => array(	
				'outline' => array(
					'style' => 'double',
				)
			)
		);
		
		$styleArray2 = array(
			'borders' => array(	
				'outline' => array(
					'style' => 'thin',
				)
			)
		);		
		
		$styleArray3 = array(
			'borders' => array(	
				'allborders' => array(
					'style' => 'thin',
				)
			)
		);		
		
		$styleArray0 = array(
			'borders' => array(
				'allborders' => array(
					'style' => 'none',
				)
			)
		);		
		$sheet->getStyle('A1:G6')->applyFromArray($styleArray0);
		
		$sheet->setCellValue('A2', 'Full report');
		
	
		$nr = 4;
		$sheet->setCellValue('A'.$nr, 'Location' )
				->setCellValue('B'.$nr, 'Contacts' )
				->setCellValue('C'.$nr, 'Station' )
				->setCellValue('D'.$nr, 'ESN' )
				->setCellValue('E'.$nr, 'Description' )
				->setCellValue('F'.$nr, 'Keys' )
				->setCellValue('G'.$nr, 'Assigned' );
			
		
		foreach($res as $asystem) {
			$nr++;			
			$sheet->setCellValue('A'.$nr, $asystem->getName() );	

			$acont = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Alertcontacts')->findByAlertsystemid( $asystem->getId() );
			$cnr = $nr;
			foreach($acont as $as) {
				$contact = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Contact')->find( $as->getContactid() );
				if ( is_object($contact) ) {
					$cnr++;				
					$sheet->setCellValue('B'.$cnr, $contact->getLname().' '.$contact->getFname() );	
				}				
			}

			// now get stations
			$astations = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Alertstations')->findByAlertsystemid( $asystem->getId() );
			$snr = $nr;
			foreach($astations as $as) {
				$snr0 = $snr;
				$station = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Station')->find( $as->getStationid() );
				if ( is_object($station) ) {
					$snr++;				
					$sheet->setCellValue('C'.$snr, $station->getName() );	
					$sheet->setCellValue('D'.$snr, $station->getEsn() );	
					$sheet->setCellValue('E'.$snr, $station->getLocation() );	
					
					// keys section
					$cnt = 0;
					$keys = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Keystations')->findByStationid( $as->getStationid() );
					foreach($keys as $ks) {
						$key = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Ibutton')->find( $ks->getIbuttonid() );
						if ( is_object($key) ) {
							
							$holderid = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Keyholder')->getIbuttonOwner( $key->getId() );
							$sheet->setCellValue('F'.$snr, 'ID:'.$key->getKey().';CRC:'.$key->getCrc() );		
							if ( $holderid > 0)  {
								$holder = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Keyholder')->find($holderid);
								if (is_object($holder)){
									$sheet->setCellValue('G'.$snr, $holder->getLname().' '.$holder->getFname() );		
								}
							}
						}
						$snr++;						
					}
				$sheet->getStyle('C'.$snr0.':G'.$snr)->applyFromArray($styleArray2);	
				}				
			}
            
			$sheet->getStyle('A'.$nr.':G'.(($cnr > $snr) ? $cnr : $snr))->applyFromArray($styleArray2);
			$sheet->getStyle('A'.$nr.':A'.(($cnr > $snr) ? $cnr : $snr))->applyFromArray($styleArray2);
			$sheet->getStyle('F'.$nr.':G'.(($cnr > $snr) ? $cnr : $snr))->applyFromArray($styleArray3);
			$sheet->getStyle('C'.$nr.':E'.(($cnr > $snr) ? $cnr : $snr))->applyFromArray($styleArray3);
			
			$nr = (($cnr > $snr) ? $cnr : $snr);
			
			
		}
		$sheet->getStyle('A4:G4')->applyFromArray($styleArray);	
		
		$sheet->getColumnDimension('A')->setWidth(20);	
		$sheet->getColumnDimension('B')->setWidth(20);	
		$sheet->getColumnDimension('C')->setWidth(20);	
		$sheet->getColumnDimension('D')->setWidth(10);	
		$sheet->getColumnDimension('E')->setWidth(20);
		$sheet->getColumnDimension('F')->setWidth(30);	
		$sheet->getColumnDimension('G')->setWidth(20);		
		
		$phpExcelObject->getActiveSheet()->setTitle('Full report');
       // Set active sheet index to the first sheet, so Excel opens this as the first sheet
		$phpExcelObject->setActiveSheetIndex(0);		
		
		return $phpExcelObject;
	}
	
}