<?php
namespace Acme\SosMonBundle\Entity;

use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\NoResultException;
use Acme\SosMonBundle\Model\Common;

class AlertusersRepository extends EntityRepository 
{

	public function isExists($alertid, $userid)
	{
		$item = $this->findBy(array('alertsystemid' => $alertid,
									'userid'        => $userid));
		return ($item) ? true : false;
	}
	
	/**
	* Assign systems to user
	*
	* @return $res array
	*/
	public function assignSystems( $id, $asystems )
	{	
		$this->deleteForUser( $id );
		
		foreach($asystems as $row) {
			$this->saveEntity( array (  'userid'     => (int)$id,
										'alertsystemid' => (int)$row) );
		}	
		return 1;
	}
	
	/**
	* getDescriptionForUser - description alertsystems for user
	*
	* @return string
	*/
	public function getDescriptionForUser( $userid )	
	{
		$stmt = $this->getEntityManager()->getConnection()->prepare('SELECT a.name FROM alertusers u, alertsystems a WHERE u.alertsystemid = a.id and u.userid = :userid ORDER BY a.name' );
		$stmt->bindValue('userid', $userid);
		$stmt->execute();
		$rows = $stmt->fetchAll();
		if (count( $rows ) == 0 ) {
			$descr = 'none';
		}
		else {
			$row = current($rows);
			$descr = $row['name'];
		}
		
		if (count( $rows ) > 1) {
			$descr .= ' and '.(count( $rows )-1).' more';
		}
		
		return $descr;
	}
	

	/**
	* Save Alertuser
	*
	* @param array $var  

	* @return entity id
	*/	
	public function saveEntity( $var )
	{
		if (($var['userid'] > 0) && ($var['alertsystemid'] > 0)) {
	
			$entity = new Alertusers();
		
			$entity->setUserid(        $var['userid'] );
			$entity->setAlertsystemid( $var['alertsystemid'] );
					
			$em = $this->getEntityManager();				
			$em->persist($entity);
			$em->flush();	
		}		
		return 1;
	}

	/**
	* Delete for user
	*
	* @param int $id
	* @return 1
	**/
	public function deleteForUser( $id )
	{		
		$this->getEntityManager()->getConnection()->executeUpdate('delete from alertusers where userid = :id', 
			array('id' => $id)
		);			 
		return 1;
	}
}