<?php

namespace Acme\SosMonBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Customers
 *
 * @ORM\Table(name="customers")
 * @ORM\Entity
 * @ORM\Entity(repositoryClass="Acme\SosMonBundle\Entity\CustomerRepository")
 */
class Customer
{
    /**
     * @var integer
     *
     * @ORM\Column(name="ownid", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="customers_ownid_seq", allocationSize=1, initialValue=1)
     */
    private $ownid;

    /**
     * @var integer
     *
     * @ORM\Column(name="keys", type="integer", nullable=true)
     */
    private $keys;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=100, nullable=true)
     */
    private $name;

    /**
     * @var string
     *
     * @ORM\Column(name="shipping", type="string", length=100, nullable=true)
     */	
	private $shipping; 
	
    /**
     * @var string
     *
     * @ORM\Column(name="billing", type="string", length=100, nullable=true)
     */	
	private $billing;
	
    /**
     * @var string
     *
     * @ORM\Column(name="contact_name", type="string", length=50, nullable=true)
     */	
	private $contact_name;
    
	/**
     * @var string
     *
     * @ORM\Column(name="contact_pos", type="string", length=50, nullable=true)
     */	
	private $contact_pos;
    
	/**
     * @var string
     *
     * @ORM\Column(name="contact_phone", type="string", length=20, nullable=true)
     */	
	private $contact_phone;

	/**
     * @var string
     *
     * @ORM\Column(name="contact_mobile", type="string", length=20, nullable=true)
     */
	private $contact_mobile;

    /**
     * @var string
     *
     * @ORM\Column(name="contact_email", type="string", length=50, nullable=true)
     */
	private $contact_email;

	
    /**
     * @var integer
     *
     * @ORM\Column(name="sentry", type="integer", nullable=true)
     */
    private $sentry;

    /**
     * @var string
     *
     * @ORM\Column(name="deflat", type="decimal", precision=15, scale=3, nullable=true)
     */
    private $deflat = '0';

    /**
     * @var string
     *
     * @ORM\Column(name="deflong", type="decimal", precision=15, scale=3, nullable=true)
     */
    private $deflong = '0';

    /**
     * @var integer
     *
     * @ORM\Column(name="rrate", type="integer", nullable=true)
     */
    private $rrate;

    /**
     * @var integer
     *
     * @ORM\Column(name="active", type="integer", nullable=true)
     */
    private $active = '0';
	
    /**
     * @var integer
     *
     * @ORM\Column(name="mstype", type="integer", nullable=true)
     */
    private $mstype = 0;	
	
    /**
     * @var integer
     *
     * @ORM\Column(name="deleted", type="integer", nullable=true)
     */
    private $deleted = 0;	

    /**
     * @var string
     *
     * @ORM\Column(name="prefix",  type="string", length=10, nullable=true)
     */
    private $prefix = '';

    /**
     * @var string
     *
     * @ORM\Column(name="billcontact",  type="string", length=100, nullable=true)
     */
    private $billcontact = '';	
	
    /**
     * @var integer
     *
     * @ORM\Column(name="fixedcount", type="integer", nullable=true)
     */
    private $fixedcount = 0;

    /**
     * @var string
     *
     * @ORM\Column(name="fixedprice", type="decimal", precision=15, scale=2, nullable=true)
     */
    private $fixedprice = 0;	
	
    /**
     * @var string
     *
     * @ORM\Column(name="extraprice", type="decimal", precision=15, scale=2, nullable=true)
     */
    private $extraprice = 0;		
	
    /**
     * Get ownid
     *
     * @return integer 
     */
    public function getOwnid()
    {
        return $this->ownid;
    }

    /**
     * Set keys
     *
     * @param integer $keys
     * @return Customer
     */
    public function setKeys($keys)
    {
        $this->keys = $keys;

        return $this;
    }

    /**
     * Get keys
     *
     * @return integer 
     */
    public function getKeys()
    {
        return $this->keys;
    }

    /**
     * Set prefix
     *
     * @param string $prefix
     * @return Customer
     */
    public function setPrefix($prefix)
    {
        $this->prefix = $prefix;

        return $this;
    }

    /**
     * Get prefix
     *
     * @return string
     */
    public function getPrefix()
    {
        return $this->prefix;
    }
	
    /**
     * Set name
     *
     * @param string $name
     * @return Customer
     */
    public function setName($name)
    {
        $this->name = $name;

        return $this;
    }

    /**
     * Get name
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }

	
   /**
     * Set shipping
     *
     * @param string $shipping
     * @return Customer
     */
    public function setShipping($shipping)
    {
        $this->shipping = $shipping;

        return $this;
    }

    /**
     * Get shipping
     *
     * @return string 
     */
    public function getShipping()
    {
        return $this->shipping;
    }
	
   /**
     * Set billing
     *
     * @param string $billing
     * @return Customer
     */
    public function setBilling($billing)
    {
        $this->billing = $billing;

        return $this;
    }

    /**
     * Get billing
     *
     * @return string 
     */
    public function getBilling()
    {
        return $this->billing;
    }
	
	
 /**
     * Set contact_name
     *
     * @param string $contact_name
     * @return Customer
     */
    public function setContact_name($contact_name)
    {
        $this->contact_name = $contact_name;

        return $this;
    }

    /**
     * Get contact_name
     *
     * @return string 
     */
    public function getContact_name()
    {
        return $this->contact_name;
    }

   /**
     * Set contact_pos
     *
     * @param string $contact_pos
     * @return Customer
     */
    public function setContact_pos($contact_pos)
    {
        $this->contact_pos = $contact_pos;

        return $this;
    }

    /**
     * Get contact_pos
     *
     * @return string 
     */
    public function getContact_pos()
    {
        return $this->contact_pos;
    }
	
   /**
     * Set contact_phone
     *
     * @param string $contact_phone
     * @return Customer
     */
    public function setContact_phone($contact_phone)
    {
        $this->contact_phone = $contact_phone;

        return $this;
    }

    /**
     * Get contact_phone
     *
     * @return string 
     */
    public function getContact_phone()
    {
        return $this->contact_phone;
    }

   /**
     * Set contact_mobile
     *
     * @param string $contact_mobile
     * @return Customer
     */
    public function setContact_mobile($contact_mobile)
    {
        $this->contact_mobile = $contact_mobile;

        return $this;
    }

    /**
     * Get contact_mobile
     *
     * @return string 
     */
    public function getContact_mobile()
    {
        return $this->contact_mobile;
    }
	
   /**
     * Set contact_email
     *
     * @param string $contact_email
     * @return Customer
     */
    public function setContact_email($contact_email)
    {
        $this->contact_email = $contact_email;

        return $this;
    }

    /**
     * Get contact_email
     *
     * @return string 
     */
    public function getContact_email()
    {
        return $this->contact_email;
    }	
	
	
	
    /**
     * Set sentry
     *
     * @param integer $sentry
     * @return Customer
     */
    public function setSentry($sentry)
    {
        $this->sentry = $sentry;

        return $this;
    }

    /**
     * Get sentry
     *
     * @return integer 
     */
    public function getSentry()
    {
        return $this->sentry;
    }

    /**
     * Set deflat
     *
     * @param string $deflat
     * @return Customer
     */
    public function setDeflat($deflat)
    {
        $this->deflat = $deflat;

        return $this;
    }

    /**
     * Get deflat
     *
     * @return string 
     */
    public function getDeflat()
    {
        return $this->deflat;
    }

    /**
     * Set deflong
     *
     * @param string $deflong
     * @return Customer
     */
    public function setDeflong($deflong)
    {
        $this->deflong = $deflong;

        return $this;
    }

    /**
     * Get deflong
     *
     * @return string 
     */
    public function getDeflong()
    {
        return $this->deflong;
    }

    /**
     * Set rrate
     *
     * @param integer $rrate
     * @return Customer
     */
    public function setRrate($rrate)
    {
        $this->rrate = $rrate;

        return $this;
    }

    /**
     * Get rrate
     *
     * @return integer 
     */
    public function getRrate()
    {
        return $this->rrate;
    }

    /**
     * Set active
     *
     * @param integer $active
     * @return Customer
     */
    public function setActive($active)
    {
        $this->active = $active;

        return $this;
    }

    /**
     * Get active
     *
     * @return integer 
     */
    public function getActive()
    {
        return $this->active;
    }
	
    /**
     * Set mstype
     *
     * @param integer $mstype
     * @return Customer
     */
    public function setMstype($mstype)
    {
        $this->mstype = $mstype;

        return $this;
    }

    /**
     * Get mstype
     *
     * @return integer 
     */
    public function getMstype()
    {
        return $this->mstype;
    }	
	
   /**
     * Set deleted
     *
     * @param string $deleted
     * @return Customer
     */
    public function setDeleted($deleted)
    {
        $this->deleted = $deleted;

        return $this;
    }

    /**
     * Get deleted
     *
     * @return string 
     */
    public function getDeleted()
    {
        return $this->deleted;
    }
	
 
   /**
     * Set billcontact
     *
     * @param string $billcontact
     * @return Customer
     */
    public function setBillcontact($billcontact)
    {
        $this->billcontact = $billcontact;

        return $this;
    }

    /**
     * Get billcontact
     *
     * @return string 
     */
    public function getBillcontact()
    {
        return $this->billcontact;
    }

   /**
     * Set fixedcount
     *
     * @param string $fixedcount
     * @return Customer
     */
    public function setFixedcount($fixedcount)
    {
        $this->fixedcount = $fixedcount;

        return $this;
    }

    /**
     * Get fixedcount
     *
     * @return string 
     */
    public function getFixedcount()
    {
        return $this->fixedcount;
    }	
	
   /**
     * Set fixedprice
     *
     * @param string $fixedprice
     * @return Customer
     */
    public function setFixedprice($fixedprice)
    {
        $this->fixedprice = $fixedprice;

        return $this;
    }

    /**
     * Get fixedprice
     *
     * @return string 
     */
    public function getFixedprice()
    {
        return $this->fixedprice;
    }

   /**
     * Set extraprice
     *
     * @param string $extraprice
     * @return Customer
     */
    public function setExtraprice($extraprice)
    {
        $this->extraprice = $extraprice;

        return $this;
    }

    /**
     * Get extraprice
     *
     * @return string 
     */
    public function getExtraprice()
    {
        return $this->extraprice;
    }	
}
