<?php

namespace Acme\SosMonBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Events
 *
 * @ORM\Table(name="events", indexes={@ORM\Index(name="events_dt", columns={"ownid", "dt"}), @ORM\Index(name="events_id", columns={"ownid", "id"}), @ORM\Index(name="events_stationid", columns={"ownid", "stationid", "dt"})})
 * @ORM\Entity
 * @ORM\Entity(repositoryClass="Acme\SosMonBundle\Entity\EventRepository") 
 */
class Event
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="events_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;

    /**
     * @var integer
     *
     * @ORM\Column(name="rawid", type="integer", nullable=true)
     */
    private $rawid;

    /**
     * @var integer
     *
     * @ORM\Column(name="ownid", type="integer", nullable=true)
     */
    private $ownid;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt", type="datetime", nullable=true)
     */
    private $dt;

    /**
     * @var integer
     *
     * @ORM\Column(name="stationid", type="integer", nullable=true)
     */
    private $stationid;

    /**
     * @var string
     *
     * @ORM\Column(name="latitude", type="decimal", precision=7, scale=3, nullable=true)
     */
    private $latitude;

    /**
     * @var string
     *
     * @ORM\Column(name="longitude", type="decimal", precision=7, scale=3, nullable=true)
     */
    private $longitude;

    /**
     * @var integer
     *
     * @ORM\Column(name="ibuttonid", type="integer", nullable=true)
     */
    private $ibuttonid = '0';

    /**
     * @var integer
     *
     * @ORM\Column(name="keyholderid", type="integer", nullable=true)
     */
    private $keyholderid = '0';

    /**
     * @var integer
     *
     * @ORM\Column(name="status", type="integer", nullable=true)
     */
    private $status = '0';

    /**
     * @var integer
     *
     * @ORM\Column(name="charge", type="integer", nullable=true)
     */
    private $charge = '0';

    /**
     * @var string
     *
     * @ORM\Column(name="edata", type="string", length=50, nullable=true)
     */
    private $edata;
	
    /**
     * @var integer
     *
     * @ORM\Column(name="response", type="integer", nullable=true)
     */
    private $response;	
	
    /**
     * @var integer
     *
     * @ORM\Column(name="response_user", type="integer", nullable=true)
     */
    private $response_user;	
	
    /**
     * @var \DateTime
     *
     * @ORM\Column(name="response_dt", type="datetime", nullable=true)
     */
    private $response_dt;


    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set rawid
     *
     * @param integer $rawid
     * @return Events
     */
    public function setRawid($rawid)
    {
        $this->rawid = $rawid;

        return $this;
    }

    /**
     * Get rawid
     *
     * @return integer 
     */
    public function getRawid()
    {
        return $this->rawid;
    }

    /**
     * Set ownid
     *
     * @param integer $ownid
     * @return Events
     */
    public function setOwnid($ownid)
    {
        $this->ownid = $ownid;

        return $this;
    }

    /**
     * Get ownid
     *
     * @return integer 
     */
    public function getOwnid()
    {
        return $this->ownid;
    }

    /**
     * Set dt
     *
     * @param \DateTime $dt
     * @return Events
     */
    public function setDt($dt)
    {
        $this->dt = $dt;

        return $this;
    }

    /**
     * Get dt
     *
     * @return \DateTime 
     */
    public function getDt()
    {
        return $this->dt;
    }

    /**
     * Set stationid
     *
     * @param integer $stationid
     * @return Events
     */
    public function setStationid($stationid)
    {
        $this->stationid = $stationid;

        return $this;
    }

    /**
     * Get stationid
     *
     * @return integer 
     */
    public function getStationid()
    {
        return $this->stationid;
    }

    /**
     * Set latitude
     *
     * @param string $latitude
     * @return Events
     */
    public function setLatitude($latitude)
    {
        $this->latitude = $latitude;

        return $this;
    }

    /**
     * Get latitude
     *
     * @return string 
     */
    public function getLatitude()
    {
        return $this->latitude;
    }

    /**
     * Set longitude
     *
     * @param string $longitude
     * @return Events
     */
    public function setLongitude($longitude)
    {
        $this->longitude = $longitude;

        return $this;
    }

    /**
     * Get longitude
     *
     * @return string 
     */
    public function getLongitude()
    {
        return $this->longitude;
    }

    /**
     * Set ibuttonid
     *
     * @param integer $ibuttonid
     * @return Events
     */
    public function setIbuttonid($ibuttonid)
    {
        $this->ibuttonid = $ibuttonid;

        return $this;
    }

    /**
     * Get ibuttonid
     *
     * @return integer 
     */
    public function getIbuttonid()
    {
        return $this->ibuttonid;
    }

    /**
     * Set keyholderid
     *
     * @param integer $keyholderid
     * @return Events
     */
    public function setKeyholderid($keyholderid)
    {
        $this->keyholderid = $keyholderid;

        return $this;
    }

    /**
     * Get keyholderid
     *
     * @return integer 
     */
    public function getKeyholderid()
    {
        return $this->keyholderid;
    }

    /**
     * Set status
     *
     * @param integer $status
     * @return Events
     */
    public function setStatus($status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * Get status
     *
     * @return integer 
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * Set charge
     *
     * @param integer $charge
     * @return Events
     */
    public function setCharge($charge)
    {
        $this->charge = $charge;

        return $this;
    }

    /**
     * Get charge
     *
     * @return integer 
     */
    public function getCharge()
    {
        return $this->charge;
    }

    /**
     * Set edata
     *
     * @param string $edata
     * @return Events
     */
    public function setEdata($edata)
    {
        $this->edata = $edata;

        return $this;
    }

    /**
     * Get edata
     *
     * @return string 
     */
    public function getEdata()
    {
        return $this->edata;
    }
	
    /**
     * Set response
     *
     * @param int $response
     * @return Events
     */
    public function setResponse($response)
    {
        $this->response = $response;

        return $this;
    }

    /**
     * Get response
     *
     * @return string 
     */
    public function getResponse()
    {
        return $this->response;
    }	
	
    /**
     * Set response_user
     *
     * @param int $response_user
     * @return Events
     */
    public function setResponse_user($response_user)
    {
        $this->response_user = $response_user;

        return $this;
    }

    /**
     * Get response_user
     *
     * @return string 
     */
    public function getResponse_user()
    {
        return $this->response_user;
    }

    /**
     * Set response_dt
     *
     * @param int $response_dt
     * @return Events
     */
    public function setResponse_dt($response_dt)
    {
        $this->response_dt = $response_dt;

        return $this;
    }

    /**
     * Get response_dt
     *
     * @return string 
     */
    public function getResponse_dt()
    {
        return $this->response_dt;
    }	
}
