<?php
namespace Acme\SosMonBundle\Entity;

use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\NoResultException;
use \DateTime;
use Acme\SosMonBundle\Model\Common;

class HistorylogRepository extends EntityRepository 
{
	/**
	* Get all Historylog
	*
	* @return $res array
	*/
	public function getList($rows, $offset, $userid, $ownid, $dt1, $dt2)
	{	
		$stmt = $this->getEntityManager()->getConnection()->prepare('SELECT * FROM getHistorylogs(:ownid, :userid, :dt1, :dt2, :rows, :offset)');
		$stmt->bindValue('ownid', $ownid);		
		$stmt->bindValue('userid', $userid);	
		$stmt->bindValue('dt1', $dt1);
		$stmt->bindValue('dt2', $dt2);
		$stmt->bindValue('rows', $rows);
		$stmt->bindValue('offset', $offset);
								  
		$stmt->execute();
		$rows = $stmt->fetchAll();	
				 
		$res = array();
		$total = 0;
		
		foreach ($rows as $row) {
			$total = (int)$row['total'];
			$res[] = array(
				'id' 		=> (int)$row['id'],		
				'ownid' 	=> (int)$row['ownid'],	
				'userid' 	=> (int)$row['userid'],
				'customer'  => $row['customer'],
				'dt' 		=> $row['dt'],				
				'ip' 		=> $row['cmd'],	
				'uname' 	=> $row['uname'],
			);
		}
		return array("total" => $total, 
					 "rows"  => $res);
	}	
	
	/**
	* Save Historylog
	*
	* @param array $var  

	* @return entity id
	*/
	public function saveEntity( $var )
	{

		$entity = new Historylog();
		
		$entity->setOwnid(    $var['ownid'] );
		$entity->setUserid(   $var['userid'] );
		$entity->setIp(       $var['ip'] );
		$entity->setDt( new DateTime);
					
		$em = $this->getEntityManager();				
		$em->persist($entity);
		$em->flush();
		return $entity->getId();			
	}

	public function exportHistorylog($phpExcelObject,  $params) 
	{
		$res = $this->getList(999999, 0, $params['userid'], $params['ownid'], $params['dt1'], $params['dt2']);
	
		
		$phpExcelObject->getProperties()->setCreator("SosMon datafile")
			->setTitle("MS Excel spreadsheet");		
	
		$sheet = $phpExcelObject->setActiveSheetIndex(0);

		$styleArray = array(
			'borders' => array(
				'inside' => array(
					'style' => 'thin',
				),		
				'outline' => array(
					'style' => 'double',
				)
			)
		);
		
		$styleArray0 = array(
			'borders' => array(
				'allborders' => array(
					'style' => 'none',
				)
			)
		);		
		$sheet->getStyle('A1:D6')->applyFromArray($styleArray0);
		
		
		$sheet->setCellValue('A2', 'History log');
		
		$entity = $this->getEntityManager()->getRepository('AcmeSosMonBundle:Customer')->findEntity($params['ownid'], 0);
		$sheet->setCellValue('A4', 'Company: '.($params['ownid'] == 0 ? 'ALL' : $entity['name']));

		$entity = $this->getEntityManager()->getRepository('AcmeSosMonBundle:User')->findEntity($params['userid'], 0);		
		$sheet->setCellValue('A4', 'User: '.($params['userid'] == 0 ? 'ALL' : $entity['username']));		
		$sheet->setCellValue('A5', 'Period :'. Common::zfdate($params['dt1'], 'sql', 'us') .
								   ' - '.Common::zfdate($params['dt2'], 'sql', 'us') );	
		$sheet->mergeCells('A5:D5');
		
		$sheet->setCellValue('A7','Company')
			->setCellValue('B7','Time')
			->setCellValue('C7','User')
			->setCellValue('D7','IP');
		$sheet->getStyle('A7:D7')->applyFromArray($styleArray);	
		$nr = 7;
		
		foreach($res['rows'] as $row) {
			$nr++;
			
			$sheet->setCellValue('A'.$nr, $row['customer'])
				->setCellValue('B'.$nr,$row['dt'])
				->setCellValue('C'.$nr,$row['uname'])
				->setCellValue('D'.$nr,$row['ip']);
			
		}
		$sheet->getStyle('A8:D'.$nr)->applyFromArray($styleArray);	
		
		$sheet->getColumnDimension('A')->setWidth(30);	
		$sheet->getColumnDimension('B')->setWidth(20);	
		$sheet->getColumnDimension('C')->setWidth(20);	
		$sheet->getColumnDimension('D')->setWidth(20);				
		
		$phpExcelObject->getActiveSheet()->setTitle('History log');
       // Set active sheet index to the first sheet, so Excel opens this as the first sheet
		$phpExcelObject->setActiveSheetIndex(0);		
		
		return $phpExcelObject;
	}
	
}

