<?php

namespace Acme\SosMonBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Ibuttons
 *
 * @ORM\Table(name="ibuttons", indexes={@ORM\Index(name="ibuttons_id", columns={"ownid", "id"}), @ORM\Index(name="contacts_name", columns={"ownid", "fname", "lname"})})
 * @ORM\Entity
 * @ORM\Entity(repositoryClass="Acme\SosMonBundle\Entity\IbuttonRepository")
 */
class Ibutton
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="ibuttons_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="key", type="string", length=16, nullable=true)
     */
    private $key;
	
    /**
     * @var string
     *
     * @ORM\Column(name="crc", type="string", length=10, nullable=true)
     */
    private $crc;	

    /**
     * @var integer
     *
     * @ORM\Column(name="ownid", type="integer", nullable=true)
     */
    private $ownid = '0';
	
    /**
     * @var integer
     *
     * @ORM\Column(name="active", type="integer", nullable=true)
     */
    private $active = '0';	

    /**
     * @var integer
     *
     * @ORM\Column(name="deleted", type="integer", nullable=true)
     */
    private $deleted = 0;

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set active
     *
     * @param integer $active
     * @return Ibuttons
     */
    public function setActive($active)
    {
        $this->active = $active;

        return $this;
    }

    /**
     * Get active
     *
     * @return integer 
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * Set key
     *
     * @param string $key
     * @return Ibuttons
     */
    public function setKey($key)
    {
        $this->key = $key;

        return $this;
    }

    /**
     * Get key
     *
     * @return string 
     */
    public function getKey()
    {
        return $this->key;
    }
	
    /**
     * Set crc
     *
     * @param string $crc
     * @return Ibuttons
     */
    public function setCrc($crc)
    {
        $this->crc = $crc;

        return $this;
    }

    /**
     * Get crc
     *
     * @return string 
     */
    public function getCrc()
    {
        return $this->crc;
    }	

    /**
     * Set ownid
     *
     * @param integer $ownid
     * @return Contacts
     */
    public function setOwnid($ownid)
    {
        $this->ownid = $ownid;

        return $this;
    }

    /**
     * Get ownid
     *
     * @return integer 
     */
    public function getOwnid()
    {
        return $this->ownid;
    }
	
    /**
     * Set deleted
     *
     * @param integer $deleted
     * @return Contacts
     */
    public function setDeleted($deleted)
    {
        $this->deleted = $deleted;

        return $this;
    }

    /**
     * Get deleted
     *
     * @return integer 
     */
    public function getDeleted()
    {
        return $this->deleted;
    }	
}
