<?php

namespace Acme\SosMonBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Sqllog
 *
 * @ORM\Table(name="sqllog", indexes={@ORM\Index(name="sqllog_dt", columns={"ownid", "dt"}), @ORM\Index(name="sqllog_id", columns={"ownid", "id"}), @ORM\Index(name="sqllog_userid", columns={"ownid", "userid", "dt"})})
 * @ORM\Entity
 * @ORM\Entity(repositoryClass="Acme\SosMonBundle\Entity\SqllogRepository") 
 */
class Sqllog
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="sqllog_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;

    /**
     * @var integer
     *
     * @ORM\Column(name="ownid", type="integer", nullable=true)
     */
    private $ownid;
	
    /**
     * @var integer
     *
     * @ORM\Column(name="userid", type="integer", nullable=true)
     */
    private $userid;	

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt", type="datetime", nullable=true)
     */
    private $dt;

    /**
     * @var integer
     *
     * @ORM\Column(name="err", type="integer", nullable=true)
     */
    private $err;

    /**
     * @var string
     *
     * @ORM\Column(name="cmd", type="string", length=500, nullable=true)
     */
    private $cmd;
	
    /**
     * @var string
     *
     * @ORM\Column(name="params", type="string", length=500, nullable=true)
     */
    private $params;	



    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set userid
     *
     * @param integer $userid
     * @return Events
     */
    public function setUserid($userid)
    {
        $this->userid = $userid;

        return $this;
    }

    /**
     * Get userid
     *
     * @return integer 
     */
    public function getUserid()
    {
        return $this->userid;
    }

    /**
     * Set ownid
     *
     * @param integer $ownid
     * @return Events
     */
    public function setOwnid($ownid)
    {
        $this->ownid = $ownid;

        return $this;
    }

    /**
     * Get ownid
     *
     * @return integer 
     */
    public function getOwnid()
    {
        return $this->ownid;
    }

    /**
     * Set dt
     *
     * @param \DateTime $dt
     * @return Events
     */
    public function setDt($dt)
    {
        $this->dt = $dt;

        return $this;
    }

    /**
     * Get dt
     *
     * @return \DateTime 
     */
    public function getDt()
    {
        return $this->dt;
    }

    /**
     * Set err
     *
     * @param integer $err
     * @return Events
     */
    public function setErr($err)
    {
        $this->err = $err;

        return $this;
    }

    /**
     * Get err
     *
     * @return integer 
     */
    public function getErr()
    {
        return $this->err;
    }


    /**
     * Set cmd
     *
     * @param string $cmd
     * @return Events
     */
    public function setCmd($cmd)
    {
        $this->cmd = $cmd;

        return $this;
    }

    /**
     * Get cmd
     *
     * @return string 
     */
    public function getCmd()
    {
        return $this->cmd;
    }
	
    /**
     * Set params
     *
     * @param string $params
     * @return Events
     */
    public function setParams($params)
    {
        $this->params = $params;

        return $this;
    }

    /**
     * Get params
     *
     * @return string 
     */
    public function getParams()
    {
        return $this->params;
    }	
}
