<?php

namespace Acme\SosMonBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Stations
 *
 * @ORM\Table(name="stations", indexes={@ORM\Index(name="stations_id", columns={"ownid", "id"}), @ORM\Index(name="stations_name", columns={"ownid", "name"})})
 * @ORM\Entity
 * @ORM\Entity(repositoryClass="Acme\SosMonBundle\Entity\StationRepository") 
 */
class Station
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="SEQUENCE")
     * @ORM\SequenceGenerator(sequenceName="stations_id_seq", allocationSize=1, initialValue=1)
     */
    private $id;

    /**
     * @var integer
     *
     * @ORM\Column(name="ownid", type="integer", nullable=true)
     */
    private $ownid = '0';

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=50, nullable=true)
     */
    private $name;

    /**
     * @var string
     *
     * @ORM\Column(name="location", type="string", length=50, nullable=true)
     */
    private $location;

    /**
     * @var string
     *
     * @ORM\Column(name="note", type="string", length=50, nullable=true)
     */
    private $note;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dstart", type="date", nullable=true)
     */
    private $dstart;

    /**
     * @var string
     *
     * @ORM\Column(name="esn", type="string", length=16, nullable=true)
     */
    private $esn;

    /**
     * @var integer
     *
     * @ORM\Column(name="type", type="integer", nullable=true)
     */
    private $type = '0';

    /**
     * @var integer
     *
     * @ORM\Column(name="status", type="integer", nullable=true)
     */
    private $status = '0';

    /**
     * @var string
     *
     * @ORM\Column(name="longitude", type="decimal", precision=7, scale=3, nullable=true)
     */
    private $longitude;

    /**
     * @var string
     *
     * @ORM\Column(name="latitude", type="decimal", precision=7, scale=3, nullable=true)
     */
    private $latitude;

    /**
     * @var integer
     *
     * @ORM\Column(name="charge", type="integer", nullable=true)
     */
    private $charge;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dcharge", type="date", nullable=true)
     */
    private $dcharge;

    /**
     * @var integer
     *
     * @ORM\Column(name="eventid", type="integer", nullable=true)
     */
    private $eventid;

    /**
     * @var integer
     *
     * @ORM\Column(name="pricing", type="integer", nullable=true)
     */
    private $pricing;	

    /**
     * @var integer
     *
     * @ORM\Column(name="deleted", type="integer", nullable=true)
     */
    private $deleted = 0;
	
    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set ownid
     *
     * @param integer $ownid
     * @return Stations
     */
    public function setOwnid($ownid)
    {
        $this->ownid = $ownid;

        return $this;
    }

    /**
     * Get ownid
     *
     * @return integer 
     */
    public function getOwnid()
    {
        return $this->ownid;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return Stations
     */
    public function setName($name)
    {
        $this->name = $name;

        return $this;
    }

    /**
     * Get name
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set location
     *
     * @param string $location
     * @return Stations
     */
    public function setLocation($location)
    {
        $this->location = $location;

        return $this;
    }

    /**
     * Get location
     *
     * @return string 
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * Set note
     *
     * @param string $note
     * @return Stations
     */
    public function setNote($note)
    {
        $this->note = $note;

        return $this;
    }

    /**
     * Get note
     *
     * @return string 
     */
    public function getNote()
    {
        return $this->note;
    }

    /**
     * Set dstart
     *
     * @param \DateTime $dstart
     * @return Stations
     */
    public function setDstart($dstart)
    {
        $this->dstart = $dstart;

        return $this;
    }

    /**
     * Get dstart
     *
     * @return \DateTime 
     */
    public function getDstart()
    {
        return $this->dstart;
    }

    /**
     * Set esn
     *
     * @param string $esn
     * @return Stations
     */
    public function setEsn($esn)
    {
        $this->esn = $esn;

        return $this;
    }

    /**
     * Get esn
     *
     * @return string 
     */
    public function getEsn()
    {
        return $this->esn;
    }

    /**
     * Set type
     *
     * @param integer $type
     * @return Stations
     */
    public function setType($type)
    {
        $this->type = $type;

        return $this;
    }

    /**
     * Get type
     *
     * @return integer 
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * Set status
     *
     * @param integer $status
     * @return Stations
     */
    public function setStatus($status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * Get status
     *
     * @return integer 
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * Set longitude
     *
     * @param string $longitude
     * @return Stations
     */
    public function setLongitude($longitude)
    {
        $this->longitude = $longitude;

        return $this;
    }

    /**
     * Get longitude
     *
     * @return string 
     */
    public function getLongitude()
    {
        return $this->longitude;
    }

    /**
     * Set latitude
     *
     * @param string $latitude
     * @return Stations
     */
    public function setLatitude($latitude)
    {
        $this->latitude = $latitude;

        return $this;
    }

    /**
     * Get latitude
     *
     * @return string 
     */
    public function getLatitude()
    {
        return $this->latitude;
    }

    /**
     * Set charge
     *
     * @param integer $charge
     * @return Stations
     */
    public function setCharge($charge)
    {
        $this->charge = $charge;

        return $this;
    }

    /**
     * Get charge
     *
     * @return integer 
     */
    public function getCharge()
    {
        return $this->charge;
    }

    /**
     * Set dcharge
     *
     * @param \DateTime $dcharge
     * @return Stations
     */
    public function setDcharge($dcharge)
    {
        $this->dcharge = $dcharge;

        return $this;
    }

    /**
     * Get dcharge
     *
     * @return \DateTime 
     */
    public function getDcharge()
    {
        return $this->dcharge;
    }

    /**
     * Set eventid
     *
     * @param integer $eventid
     * @return Stations
     */
    public function setEventid($eventid)
    {
        $this->eventid = $eventid;

        return $this;
    }

    /**
     * Get eventid
     *
     * @return integer
     */
    public function getEventid()
    {
        return $this->eventid;
    }
	
    /**
     * Set pricing
     *
     * @param integer $pricing
     * @return Stations
     */
    public function setPricing($pricing)
    {
        $this->pricing = $pricing;

        return $this;
    }

    /**
     * Get pricing
     *
     * @return integer
     */
    public function getPricing()
    {
        return $this->pricing;
    }	
	
    /**
     * Set deleted
     *
     * @param integer $deleted
     * @return Contacts
     */
    public function setDeleted($deleted)
    {
        $this->deleted = $deleted;

        return $this;
    }

    /**
     * Get deleted
     *
     * @return integer 
     */
    public function getDeleted()
    {
        return $this->deleted;
    }	
}
