<?php

namespace Acme\SosMonBundle\Entity;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Security\Core\User\EquatableInterface;
use Doctrine\ORM\Mapping as ORM;

/**
 * User
 *
 * @ORM\Table(name="users", uniqueConstraints={@ORM\UniqueConstraint(name="id", columns={"id"})})
 * @ORM\Entity(repositoryClass="Acme\SosMonBundle\Entity\UserRepository")
 */
class User implements UserInterface, EquatableInterface, \Serializable
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="bigint", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=100, nullable=false)
     */
    private $name;
	
    /**
     * @var string
     *
     * @ORM\Column(name="username", type="string", length=200, nullable=false)
     */
    private $username;

    /**
     * @var string
     *
     * @ORM\Column(name="password", type="string", length=200, nullable=false)
     */
    private $password;

    /**
     * @var integer
     *
     * @ORM\Column(name="acclevel", type="bigint", nullable=false)
     */
    private $acclevel;
	
    /**
     * @var integer
     *
     * @ORM\Column(name="chgpassword", type="bigint", nullable=false)
     */
    private $chgpassword;	
	
    /**
     * @var integer
     *
     * @ORM\Column(name="ownid", type="bigint", nullable=false)
     */
    private $ownid;	

    /**
     * @var integer
     *
     * @ORM\Column(name="active", type="bigint", nullable=false)
     */
    private $active;	
	
    /**
     * @var integer
     *
     * @ORM\Column(name="deleted", type="bigint", nullable=false)
     */
    private $deleted;	
	
    /**
     * @var integer
     *
     * @ORM\Column(name="alertcontactid", type="bigint", nullable=false)
     */
    private $alertcontactid;	

    /**
     * @var string
     *
     * @ORM\Column(name="phone", type="string", length=50, nullable=false)
     */
    private $phone;
	
    /**
     * @var string
     *
     * @ORM\Column(name="mobile", type="string", length=50, nullable=false)
     */
    private $mobile;
	
    /**
     * @var string
     *
     * @ORM\Column(name="email", type="string", length=50, nullable=false)
     */
    private $email;	
	
    /**
     * @var string
     *
     * @ORM\Column(name="accword", type="string", length=40, nullable=false)
     */
    private $accword;		

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return User
     */
    public function setName($name)
    {
        $this->name = $name;

        return $this;
    }

    /**
     * Get username
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }	
    /**
     * Set username
     *
     * @param string $username
     * @return User
     */
    public function setUsername($username)
    {
        $this->username = $username;

        return $this;
    }

    /**
     * Get username
     *
     * @return string 
     */
    public function getUsername()
    {
        return $this->username;
    }
	
    /**
     * Set phone
     *
     * @param string $phone
     * @return User
     */
    public function setPhone($phone)
    {
        $this->phone = $phone;

        return $this;
    }

    /**
     * Get phone
     *
     * @return string 
     */
    public function getPhone()
    {
        return $this->phone;
    }	
	
    /**
     * Set mobile
     *
     * @param string $mobile
     * @return User
     */
    public function setMobile($mobile)
    {
        $this->mobile = $mobile;

        return $this;
    }

    /**
     * Get mobile
     *
     * @return string 
     */
    public function getMobile()
    {
        return $this->mobile;
    }	
	
    /**
     * Set email
     *
     * @param string $email
     * @return User
     */
    public function setEmail($email)
    {
        $this->email = $email;

        return $this;
    }

    /**
     * Get email
     *
     * @return string 
     */
    public function getEmail()
    {
        return $this->email;
    }	

    /**
     * Set accword
     *
     * @param string $accword
     * @return User
     */
    public function setAccword($accword)
    {
        $this->accword = $accword;

        return $this;
    }

    /**
     * Get accword
     *
     * @return string 
     */
    public function getAccword()
    {
        return $this->accword;
    }	
	
    /**
     * Set password
     *
     * @param string $password
     * @return User
     */
    public function setPassword($password)
    {
        $this->password = $password;

        return $this;
    }

    /**
     * Get password
     *
     * @return string 
     */
    public function getPassword()
    {
        return $this->password;
    }
	
    /**
     * Get acclevel
     *
     * @return integer 
     */
    public function getAcclevel()
    {
        return $this->acclevel;
    }
	
    /**
     * Set acclevel
     *
     * @param string $acclevel
     * @return User
     */
    public function setAcclevel($acclevel)
    {
        $this->acclevel = $acclevel;

        return $this;
    }	
	
    /**
     * Get ownid
     *
     * @return integer 
     */
    public function getOwnid()
    {
        return $this->ownid;
    }
	
    /**
     * Set ownid
     *
     * @param string $ownid
     * @return User
     */
    public function setOwnid($ownid)
    {
        $this->ownid = $ownid;

        return $this;
    }
	
    /**
     * Get active
     *
     * @return integer 
     */
    public function getActive()
    {
        return $this->active;
    }
	
    /**
     * Set active
     *
     * @param string $active
     * @return User
     */
    public function setActive($active)
    {
        $this->active = $active;

        return $this;
    }
	
    /**
     * Get deleted
     *
     * @return integer 
     */
    public function getDeleted()
    {
        return $this->deleted;
    }
	
    /**
     * Set deleted
     *
     * @param string $deleted
     * @return User
     */
    public function setDeleted($deleted)
    {
        $this->deleted = $deleted;

        return $this;
    }
	
    /**
     * Get alertcontactid
     *
     * @return integer 
     */
    public function getAlertcontactid()
    {
        return $this->alertcontactid;
    }
	
    /**
     * Set alertcontactid
     *
     * @param string $alertcontactid
     * @return User
     */
    public function setAlertcontactid($alertcontactid)
    {
        $this->alertcontactid = $alertcontactid;

        return $this;
    }	
	
    /**
     * Get chgpassword
     *
     * @return integer 
     */
    public function getChgpassword()
    {
        return $this->chgpassword;
    }
	
    /**
     * Set chgpassword
     *
     * @param string $chgpassword
     * @return User
     */
    public function setChgpassword($chgpassword)
    {
        $this->chgpassword = $chgpassword;

        return $this;
    }		
	
	
	public function __constructor($id, $username, $password)
	{
		$this->id = $id;
		$this->username = $username;
		$this->password = $password;
		
	}
	
    public function getRoles()
    {
        return array('ROLE_ADMIN');
    }

    public function getSalt()
    {
        return '';
    }

    public function eraseCredentials()
    {
    }

    public function isEqualTo(UserInterface $user)
    {
        if (!$user instanceof WebserviceUser) {
            return false;
        }

        if ($this->password !== $user->getPassword()) {
            return false;
        }

        if ($this->getSalt() !== $user->getSalt()) {
            return false;
        }

        if ($this->username !== $user->getUsername()) {
            return false;
        }

        return true;
    }
	
    /**
     * @see \Serializable::serialize()
     */
    public function serialize()
    {
        return serialize(array(
            $this->id,
            $this->username,
            $this->password,
            // see section on salt below
            // $this->salt,
        ));
    }

    /**
     * @see \Serializable::unserialize()
     */
    public function unserialize($serialized)
    {
        list (
            $this->id,
            $this->username,
            $this->password,
            // see section on salt below
            // $this->salt
        ) = unserialize($serialized);
    }	
}
