<?php 
namespace Acme\SosMonBundle\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

class CustomerType extends AbstractType
{
	public function buildForm(FormBuilderInterface $builder, array $options)
	{			
	
		$options['autocomplete'] = 'off';
		
		$builder->add('prefix', 'text', array(
						'label' => 'Prefix',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off", "maxlength" => "10"),						
					));	
					
		$builder->add('name', 'text', array(
						'label' => 'Name',
						'attr'  => array("class" => "form_text400Class", "autocomplete" => "off", "maxlength" => "100"),						
					));	
					
		$builder->add('shipping', 'text', array(
						'label' => 'Shipping',
						'attr'  => array("class" => "form_text400Class", "autocomplete" => "off", "maxlength" => "100"),						
					));	

		$builder->add('billing', 'text', array(
						'label' => 'Billing',
						'attr'  => array("class" => "form_text400Class", "autocomplete" => "off", "maxlength" => "100"),						
					));		

		$builder->add('contact_name', 'text', array(
						'label' => 'Contact name',
						'attr'  => array("class" => "form_text400Class", "autocomplete" => "off", "maxlength" => "50"),						
					));		

		$builder->add('contact_pos', 'text', array(
						'label' => 'Contact position',
						'attr'  => array("class" => "form_text400Class", "autocomplete" => "off", "maxlength" => "50"),						
					));	

		$builder->add('contact_phone', 'text', array(
						'label' => 'Contact phone',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off", "maxlength" => "20"),						
					));	

		$builder->add('contact_mobile', 'text', array(
						'label' => 'Contact mobile',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off", "maxlength" => "20"),						
					));	

		$builder->add('contact_email', 'text', array(
						'label' => 'Contact email',
						'attr'  => array("class" => "form_text400Class", "autocomplete" => "off", "maxlength" => "50"),						
					));	

		$builder->add('billcontact', 'text', array(
						'label' => 'Bill contact',
						'attr'  => array("class" => "form_text400Class", "autocomplete" => "off", "maxlength" => "100"),						
					));	

		$builder->add('fixedcount', 'text', array(
						'label' => 'Monthly pings',
						'attr'  => array("class" => "form_text100Class", "autocomplete" => "off"),						
					));					
		
		$builder->add('fixedprice', 'text', array(
						'label' => 'for fixed rent',
						'attr'  => array("class" => "form_text100Class", "autocomplete" => "off"),						
					));	
					
		$builder->add('extraprice', 'text', array(
						'label' => 'Extra ping cost',
						'attr'  => array("class" => "form_text100Class", "autocomplete" => "off"),						
					));						

		$builder->add('rrate', 'text', array(
						'label' => 'Refresh (min)',
						'attr'  => array("class" => "form_text100Class", "autocomplete" => "off"),						
					));	

		$builder->add('deflat', 'text', array(
						'label' => 'Latitude',
						'attr'  => array("class" => "form_text100Class", "autocomplete" => "off"),						
					));
					
		$builder->add('deflong', 'text', array(
						'label' => 'Longitude',
						'attr'  => array("class" => "form_text100Class", "autocomplete" => "off"),						
					));		

		$builder->add('mstype', 'choice', array(
						'label'   => 'Marker icons',
						'choices' => $options['data']['markerimg'],
						'attr'    => array("class" => "form_text100Class"),						
					));						
				
		$builder->add('ownid', 'hidden');
		$builder->add('active', 'hidden');
		$builder->add('keys', 'hidden');
		$builder->add('sentry', 'hidden');
					
	}
	
	public function getName()
	{
		return 'customer';
	}
}
