<?php 
namespace Acme\SosMonBundle\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

class StationType extends AbstractType
{
	public function buildForm(FormBuilderInterface $builder, array $options)
	{			
	
		$options['autocomplete'] = 'off';
		$builder->add('name', 'text', array(
						'label' => 'Name',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));
					
		$builder->add('location', 'text', array(
						'label' => 'Description',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));		

		$builder->add('note', 'textarea', array(
						'label' => 'Note',
						'attr'  => array("class" => "form_text540Class", "autocomplete" => "off", "style" => "height:70px"),						
					));		
					
		$builder->add('esn', 'text', array(
						'label' => 'Esn',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));
					
		$builder->add('longitude', 'text', array(
						'label' => 'Longitude',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));

		$builder->add('latitude', 'text', array(
						'label' => 'Latitude',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));		

		$builder->add('charge', 'text', array(
						'label' => 'Charge (%)',
						'attr'  => array("class" => "fld_readonly200", "autocomplete" => "off", "readonly" => "readonly"),						
					));	
		$builder->add('pricing', 'choice', array(
						'label' => 'Pricing',
						'choices' => $options['data']['pricing_list'], 
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));					
					
		$builder->add('type', 'choice', array(
						'label' => 'Type',
						'choices' => $options['data']['types'],						
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));	

		$builder->add('status', 'choice', array(
						'label' => 'Status',
						'choices' => $options['data']['statuses'],
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));		
					
		$builder->add('alertsystemid', 'choice', array(
						'label' => 'Location',
						'choices' => $options['data']['locations'],
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));					

		$builder->add('dstart', 'text', array(
						'label' => 'Started',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));	

		$builder->add('dcharge', 'text', array(
						'label' => 'Charged',
						'attr'  => array("class" => "fld_readonly200", "autocomplete" => "off", "readonly" => "readonly"),						
					));	

		$builder->add('devent', 'text', array(
						'label' => 'Last event',
						'attr'  => array("class" => "fld_readonly200", "autocomplete" => "off", "readonly" => "readonly"),						
					));						
											
		$builder->add('id', 'hidden');	
		$builder->add('ownid', 'hidden');
		$builder->add('eventid', 'hidden');
		$builder->add('asystems', 'hidden');		
		$builder->add('keys', 'hidden');
				
	}
	
	public function getName()
	{
		return 'station';
	}
}
