<?php 
namespace Acme\SosMonBundle\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

class UserType extends AbstractType
{
	public function buildForm(FormBuilderInterface $builder, array $options)
	{			
	
		$options['autocomplete'] = 'off';
		$builder->add('name', 'text', array(
						'label' => 'Name',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));
					
		$builder->add('acclevel', 'choice', array(
						'label'   => 'Access',
						'choices' => $options['data']['access'],
						'attr'    => array("class" => "form_text200Class"),						
					));	
	
		if ($options['data']['ownid'] > 0) {
			$builder->add('alertcontactid', 'choice', array(
					'label'   => 'Alert contact',
					'choices' => $options['data']['contacts'],
					'attr'    => array("class" => "form_text200Class"),						
			));			
		}					
		else {
			$builder->add('alertcontactid', 'text', array(
					'label'   => 'Alert contact',
					'attr'    => array("class" => "form_text200Class"),						
			));				
		}
				
		$builder->add('login', 'text', array(
						'label' => 'Login',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));

		$builder->add('password', 'text', array(
						'label' => 'Password',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));		

		$builder->add('phone', 'text', array(
						'label' => 'Phone',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));		
					
		$builder->add('mobile', 'text', array(
						'label' => 'Mobile',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));		

		$builder->add('email', 'text', array(
						'label' => 'Email',
						'attr'  => array("class" => "form_text200Class", "autocomplete" => "off"),						
					));							
											
		$builder->add('userid', 'hidden');	
		$builder->add('ownid', 'hidden');
		$builder->add('active', 'hidden');
		$builder->add('deleted', 'hidden');		
		$builder->add('accword', 'hidden');	
		$builder->add('asystems', 'hidden');	
		$builder->add('prefix', 'hidden');		
	}
	
	public function getName()
	{
		return 'user';
	}
}
