<?php
namespace Acme\SosMonBundle\Model;
use Acme\SosMonBundle\Model\Common;

class CallRegistration
{
	private $em;
	private $logger;
	
	public function __construct($em, $logger) {
		$this->em = $em;
		$this->logger = $logger;
	}


	/**
	* Making phone registration
	*
	* @param int $contactid  
	* @param int $eventid
	* @param int $success
	* @return void
	*/
	public function regPhoneNotification($contactid, $eventid = 0, $success = 0 )
	{
	    // 5073887313
		// 8185550100
		
		$this->em->getRepository('AcmeSosMonBundle:Notifications')->saveEntity(array('contactid' => $contactid,
								'ntype'     => 1,
								'eventid'   => $eventid,
								'success'   => $success));		
	}
	
	/**
	* Making sms registration
	*
	* @param int $contactid  
	* @param int $eventid
	* @param int $success
	* @return void
	*/
	public function regSmsNotification($contactid, $eventid = 0, $success = 0 )
	{
		$this->em->getRepository('AcmeSosMonBundle:Notifications')->saveEntity(array('contactid' => $contactid,
								'ntype'     => 2,
								'eventid'   => $eventid,
								'success'   => $success));
	}
	
	/**
	* Making email registration
	*
	* @param int $contactid  
	* @param int $eventid
	* @param int $success
	* @return void
	*/
	public function regEmailNotification($contactid, $eventid = 0, $success = 0 )
	{
		$this->em->getRepository('AcmeSosMonBundle:Notifications')->saveEntity(array('contactid' => $contactid,
								'ntype'     => 3,
								'eventid'   => $eventid,
								'success'   => $success));
	}
	
	/**
	* Making close registration
	*
	* @param int $contactid  
	* @param int $eventid
	* @param int $success
	* @return void
	*/
	public function regCloseNotification($contactid, $eventid = 0, $success = 1 )
	{
		$this->em->getRepository('AcmeSosMonBundle:Notifications')->saveEntity(array('contactid' => $contactid,
								'ntype'     => 4,
								'eventid'   => $eventid,
								'success'   => $success));
		}

	/**
	* call to Voiceshot
	*
	* @param string $phone
	* @param string $message
	*/		
	public function sendCall( $phone, $message)
	{	
		$input_xml = VoiceshotConfig::getXMLSequence( $phone, $message );
	

	//	$this->logger->warn( 'CALL TO :'.$input_xml );

		$data = '';
			
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, VoiceshotConfig::getUrl() );
// Following line is compulsary to add as it is:
		curl_setopt($ch, CURLOPT_POSTFIELDS, $input_xml);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 300);
		$data = curl_exec($ch);
		curl_close($ch);
		
	//	$this->logger->warn( 'CALL RESPONSE : '.Common::processXMLToJSON( $data ) );

	}
}