<?php

namespace Acme\SosMonBundle\Model;
use Symfony\Component\HttpFoundation\Response;

class ExcelProcessing
{
	private $kernel;
	private $em;
	private $phpexcel;
	
/**
* excelOut
* /summaryexport
* @return Response
*/	
	public function __construct($kernel, $em, $phpexcel) {
		$this->kernel = $kernel;
		$this->em = $em;
		$this->phpexcel = $phpexcel;
	}

	public function excelOut($phpExcelObject, $filename)
	{
        // create the writer
		$writer = $this->phpexcel->createWriter($phpExcelObject, 'Excel5');
        // create the response
		$response = new Response();
		$response = $this->phpexcel->createStreamedResponse($writer);
        // adding headers
		$response->headers->set('Content-Type', 'text/vnd.ms-excel; charset=utf-8');
		$response->headers->set('Content-Disposition', 'attachment;filename='.$filename.'.xls');
		$response->headers->set('Pragma', 'public');
		$response->headers->set('Cache-Control', 'maxage=1');

		return $response; 		
	}	
	
	public function pdfOut($phpExcelObject, $filename)
	{			
//		$classPath = $this->kernel->getRootDir() .'/../vendor/dompdf/dompdf';	
//		$rendererName = \PHPExcel_Settings::PDF_RENDERER_DOMPDF;
//		$rendererLibraryPath = $classPath;

		$classPath = $this->kernel->getRootDir() .'/../vendor/mpdf/mpdf';	
		$rendererName = \PHPExcel_Settings::PDF_RENDERER_MPDF;
		$rendererLibraryPath = $classPath;

		
		if (!\PHPExcel_Settings::setPdfRenderer(
			$rendererName,
			$rendererLibraryPath
		)) {
		die(
			'Please set the $rendererName and $rendererLibraryPath values' .PHP_EOL .' as appropriate for your directory structure'
			);
		}
	
        // create the writer
		$writer = $this->phpexcel->createWriter($phpExcelObject, 'PDF');
        // create the response
		$response = new Response();

		header('Content-Type: application/pdf');
		header('Content-Disposition: attachment;filename="'.$filename.'.pdf"');
		header('Cache-Control: max-age=0');		
		$writer->save('php://output');
		
		return $response; 		
	}		
}