<?php

namespace Acme\SosMonBundle\Tests\Controller;

use Symfony\Bundle\FrameworkBundle\Test\WebTestCase;
use Acme\SosMonBundle\Entity\Alertcampaign;
use Acme\SosMonBundle\Model\Common;

class AlertcampaignControllerTest extends WebTestCase
{

	public function testModel() 
	{
		$kernel = static::createKernel();
		$kernel->boot();
		$em = $kernel->getContainer()->get('doctrine.orm.entity_manager');	
		
		$reps = $em->getRepository('AcmeSosMonBundle:Alertcampaign');	
		$eventid = 13395;
		
		$reps->removeCampaign($eventid);
		
		$cnt = $reps->createCampaign( $eventid, 521 );
		$this->assertTrue($cnt > 0);
		
		$result = $reps->getFirstForCampaign( -2 );
		$this->assertFalse( $result->getFound() );
				
		$result = $reps->getFirstForCampaign( $eventid );
		$this->assertTrue( $result->getFound());
		echo $result->getPhone()."\r\n";
		
		$item = $reps->findOneBy(  array('eventid'=> $eventid, 'status' => 1, 'deleted' => 0));
		$this->assertTrue( $result->getPhone() == $item->getPhone() );
		
		for ($i = 1; $i <= 10; $i++) {
			$result = $reps->getNextForCampaign( $result->getPhone() );
			$this->assertTrue( $result->getFound() );
			$item = $reps->findOneBy(  array('eventid'=> $eventid, 'status' => 1, 'deleted' => 0));
			echo $result->getPhone()."---".$item->getCalls()."\r\n";
		}
		$reps->stopCampaign( $result->getPhone() );
		$item = $reps->findOneBy(  array('eventid'=> $eventid, 'deleted' => 0));
		
		$this->assertTrue( ($item) == false );
		
	}
	
	public function testResp()
	{

		
	
	}
	
   	
}