<?php

namespace Acme\SosMonBundle\Tests\Controller;

use Symfony\Bundle\FrameworkBundle\Test\WebTestCase;
use Acme\SosMonBundle\Entity\Alertsystem;

class AlertsystemControllerTest extends WebTestCase
{

	public function testModel() 
	{
		$kernel = static::createKernel();
		$kernel->boot();
		$em = $kernel->getContainer()->get('doctrine.orm.entity_manager');	

		$reps = $em->getRepository('AcmeSosMonBundle:Alertsystem');
		
		//save entity
		// add new
		$id = $reps->saveEntity(  array( 
									'id'       => 0,
									'ownid'    => -2,
									'name'      => 'ABCD',
								));
		$this->assertTrue($id > 0);	

		$id = $reps->saveEntity(  array( 
									'id'       => $id,
									'ownid'    => 1,
									'name'      => 'ABCDEF',
								));	
		$entity = $reps->findEntity( $id, 1 );																				
		
		$this->assertTrue($entity['id']    == $id);	
		$this->assertTrue($entity['ownid'] == 1);	
		$this->assertTrue($entity['name']   == 'ABCDEF');

		
		$list = $reps->getList( 1 );
		$this->assertTrue(count($list) > 0);   // at least one customer exists		
		$reps->deleteEntity( $id );
		
		$em->getRepository('AcmeSosMonBundle:Alertcontacts')->assignContacts( 18, explode( ',', '31,32' ) );
	}

/*
	index route - must show login form
		
	public function testIndex()
	{
        $client = static::createClient();
        $crawler = $client->request('GET', '/app/contacts');
        $this->assertTrue($crawler->filter('html:contains("Contacts")')->count() > 0);	
	}
*/	
/*
	users_data route - must show login form
	
	public function testData()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));

		$client->request('GET', '/app/contacts_data');
		$this->assertTrue(is_array(json_decode( $client->getResponse()->getContent() )));

	}	
*/	
/*
	entity route 
	
	public function testEntity()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));

		$crawler = $client->request('GET', '/app/customers_entity/66');
		$this->assertTrue($crawler->filter('html:contains("Sentry")')->count() > 0);

	}	
*/	
	
/*
	delete route 
	
	public function testDelete()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));

		$client->request('GET', '/app/customers_delete/1');
		$obj = json_decode($client->getResponse()->getContent());
		$this->assertTrue($obj->success);

	}
*/	
}