<?php

namespace Acme\SosMonBundle\Tests\Controller;

use Symfony\Bundle\FrameworkBundle\Test\WebTestCase;
use Acme\SosMonBundle\Entity\Keyholder;

class KeyholderControllerTest extends WebTestCase
{

	public function testModel() 
	{
		$kernel = static::createKernel();
		$kernel->boot();
		$em = $kernel->getContainer()->get('doctrine.orm.entity_manager');	
		
		$ownid = $em->getRepository('AcmeSosMonBundle:Customer')->getTestOwnid();

		$reps = $em->getRepository('AcmeSosMonBundle:Keyholder');
		
		//save entity
		// add new
		$id = $reps->saveEntity(  array( 
									'id'       => 0,		
									'ownid'   => -2,
									'fname'    => 'John',
									'lname'    => 'Doe',
									'phone'    => '1',
									'ibuttonid' => 1,
								));
		$this->assertTrue($id > 0);	

		$id = $reps->saveEntity(  array( 
									'id'       => $id,		
									'ownid'   => 1,
									'fname'    => 'Ilya',
									'lname'    => 'Laurov',
									'phone'   =>  '11',
									'ibuttonid' => 2,
								));		
		$entity = $reps->findEntity( $id, $ownid );																				
		
		$this->assertTrue($entity['id']    == $id);	
		$this->assertTrue($entity['ownid'] == 1);	
		$this->assertTrue($entity['ibuttonid']	== 2);
		$this->assertTrue($entity['phone']     == '11');
		
		$list = $reps->getList( 1, '' );
		$this->assertTrue(count($list) > 0);   // at least one customer exists		
		$reps->deleteEntity( $id );
	}

/*
	index route - must show login form
		
	public function testIndex()
	{
        $client = static::createClient();
        $crawler = $client->request('GET', '/app/keyholders');
        $this->assertTrue($crawler->filter('html:contains("Keyholders")')->count() > 0);	
	}
*/	
/*
	users_data route - must show login form
	
	public function testData()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));

		$client->request('GET', '/app/keyholders_data');
		$this->assertTrue(is_array(json_decode( $client->getResponse()->getContent() )));

	}	
*/	
/*
	entity route 
	
	public function testEntity()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));

		$crawler = $client->request('GET', '/app/customers_entity/66');
		$this->assertTrue($crawler->filter('html:contains("Sentry")')->count() > 0);

	}	
*/	
	
/*
	delete route 
	
	public function testDelete()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));

		$client->request('GET', '/app/customers_delete/1');
		$obj = json_decode($client->getResponse()->getContent());
		$this->assertTrue($obj->success);

	}
*/	
}