<?php

namespace Acme\SosMonBundle\Tests\Controller;

use Symfony\Bundle\FrameworkBundle\Test\WebTestCase;
use Acme\SosMonBundle\Entity\Ibutton;

class RawControllerTest extends WebTestCase
{

	public function testModel() 
	{
		$kernel = static::createKernel();
		$kernel->boot();
		$em = $kernel->getContainer()->get('doctrine.orm.entity_manager');	
		$rep = $em->getRepository('AcmeSosMonBundle:Raw');
		
		$entity = $rep->findEntity(0);
		$this->assertTrue($entity['id'] == 0);		
		$this->assertTrue($entity['success'] == 0);		
		$this->assertTrue(strlen($entity['message']) == 0);		
		
		$id = $rep->saveEntity(array('message' => 'test',
									 'success' => 0)
								);
		$this->assertTrue( $id > 0 );								
		$entity = $rep->findEntity($id);
		$this->assertTrue($entity['id'] == $id);		
		$this->assertTrue($entity['success'] == 0);		
		$this->assertTrue($entity['message'] == 'test');	

		$rep->setFinalize($id, 1);
		$entity = $rep->findEntity($id);
		$this->assertTrue($entity['id'] == $id);		
		$this->assertTrue($entity['success'] == 1);		
		
		
		$id = $rep->saveEntity(array('messae' => 'test',
									 'success' => 0)
								);
		$this->assertTrue( $id == 0 );																
		
		$id = $rep->saveEntity(array('message' => 'test')
								);
		$this->assertTrue( $id > 0 );																


		$id = $rep->saveEntity(array());
		$this->assertTrue( $id == 0 );																


		$id = $rep->saveEntity(21);
		$this->assertTrue( $id == 0 );					

		$arr = $rep->getList(100, 0, '20150101', '20150505', 1);//($rows, $offset, $dt1, $dt2, $success)
		$this->assertTrue( is_array($arr) );	
		$this->assertTrue( isset($arr['rows']) );			

	}
	
//path:     /app/raws	
	public function testRaws()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));
        $crawler = $client->request('GET', '/app/raws');
        $this->assertTrue($crawler->filter('html:contains("Raw data")')->count() > 0);	
		
		// refresh
		$link = $crawler
			->filter('a:contains("Search")') // find all links with the text "Greet"
			->eq(0) // select the second link in the list
			->link(); // and click it

		$crawler = $client->click($link);		
		$this->assertTrue($crawler->filter('html:contains("raws")')->count() > 0);	
		
	

		//$this->assertTrue($crawler->filter('html:contains("raws")')->count() > 0);		

	}

/*
    
    path:     /app/raws_data
*/	
	public function testData()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));

		$crawler = $client->request('GET', '/app/raws_data');
		$this->assertTrue($crawler->filter('html:contains("rows")')->count() > 0);

	}	
	
/*
	entity route 
    path:     /app/raws_entity/{id}
*/	
	public function testEntity()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));
			
		$kernel = static::createKernel();
		$kernel->boot();
		$em = $kernel->getContainer()->get('doctrine.orm.entity_manager');	
		$rep = $em->getRepository('AcmeSosMonBundle:Raw');			
		$id = $rep->saveEntity(array('message' => 'test',
									 'success' => 0));
									 
		$crawler = $client->request('GET', '/app/raws_entity/'.$id);
		$this->assertTrue($crawler->filter('html:contains("Message")')->count() > 0);

	}	

	
/*
	delete route 
	
	public function testDelete()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));

		$client->request('GET', '/app/customers_delete/1');
		$obj = json_decode($client->getResponse()->getContent());
		$this->assertTrue($obj->success);

	}
*/	
}