<?php

namespace Acme\SosMonBundle\Tests\Controller;

use Symfony\Bundle\FrameworkBundle\Test\WebTestCase;
use Acme\SosMonBundle\Entity\Station;
use \DateTime;

class StationControllerTest extends WebTestCase
{

	public function testModel() 
	{
		$kernel = static::createKernel();
		$kernel->boot();
		$em = $kernel->getContainer()->get('doctrine.orm.entity_manager');	

		$reps = $em->getRepository('AcmeSosMonBundle:Station');
		
		//save entity
		// add new
		$d1 = new DateTime();
		$id = $reps->saveEntity(  array( 
				'id' 		=> 0,			
				'ownid'     => -2,
				'name' 		=> 'st',	
				'location' 	=> 'loc',			
				'note' 		=> 'not',		
				'esn' 		=> 'esn',
				'type'		=> 1,	
				'dstart' 	=> $d1,
				'status'	=> 1,
				'longitude' => 1,				
				'latitude' 	=> 2,	
				'charge'	=> 10,
				'pricing'   => 0,
				'eventid'   => 0,
				'dcharge' 	=> '03/20/2015',
				'devent' 	=> $d1,
								));
										
		$this->assertTrue($id > 0);	
		$d1 = new DateTime();
		$id = $reps->saveEntity(  array( 
				'id' 		=> $id,		
				'ownid'     => 1,				
				'name' 		=> 'stan',	
				'location' 	=> 'location',			
				'note' 		=> 'note',		
				'esn' 		=> '12345',
				'type'		=> 2,	
				'dstart' 	=> $d1,
				'status'	=> 2,
				'longitude' => 100.12,				
				'latitude' 	=> 200.23,	
				'charge'	=> 70,
				'pricing'   => 0,
				'eventid'   => 0,
				'dcharge' 	=> '03/20/2015',
				'devent' 	=> $d1,
								));		
		$entity = $reps->findEntity( $id, 1 );																				
		
		$this->assertTrue($entity['id']    == $id);	
		$this->assertTrue($entity['ownid'] == 1);	
		$this->assertTrue($entity['name']     == 'stan');
		$this->assertTrue($entity['location']     == 'location');
		$this->assertTrue($entity['note']     == 'note');
		$this->assertTrue($entity['esn']     == '12345');
		$this->assertTrue($entity['type']     == 2);
		$this->assertTrue($entity['dstart']     == $d1);
		$this->assertTrue($entity['status']     == 2);
		$this->assertTrue($entity['longitude']     == 100.12);
		$this->assertTrue($entity['latitude']     == 200.23);
		$this->assertTrue($entity['charge']     == 70);
		$this->assertTrue($entity['dcharge']     == $d1);
		$this->assertTrue($entity['devent']     == $d1);		
		
		$list = $reps->getList( 1 );
		$this->assertTrue(count($list) > 0);   // at least one customer exists		
		$reps->deleteEntity( $id );
		
	}

/*
	index route - must show login form
		
	public function testIndex()
	{
        $client = static::createClient();
        $crawler = $client->request('GET', '/app/stations');
        $this->assertTrue($crawler->filter('html:contains("Stations")')->count() > 0);	
	}
*/	
/*
	users_data route - must show login form
	
	public function testData()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));

		$client->request('GET', '/app/stations_data');
		$this->assertTrue(is_array(json_decode( $client->getResponse()->getContent() )));

	}	
*/	
/*
	entity route 
	
	public function testEntity()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));

		$crawler = $client->request('GET', '/app/customers_entity/66');
		$this->assertTrue($crawler->filter('html:contains("Sentry")')->count() > 0);

	}	
*/	
	
/*
	delete route 
	
	public function testDelete()
	{
		$client = static::createClient(array(), array(
			'PHP_AUTH_USER' => '111',
			'PHP_AUTH_PW'   => '222',
			));

		$client->request('GET', '/app/customers_delete/1');
		$obj = json_decode($client->getResponse()->getContent());
		$this->assertTrue($obj->success);

	}
*/	
}