<?php

namespace Acme\SosMonBundle\Model;
use \DateTime;
class Payload
{
	static public function Decode9byte( $payload ) {
		$byte0 = substr($payload, 2,2);
		$byte1 = substr($payload, 4,2);
		$byte2 = substr($payload, 6,2);
		$byte3 = substr($payload, 8,2);
		
		$result = array( 'issys' => false, // is system message
						 'door1' => 0, // closed
						 'door2' => 0, // closed
						 'byte3' => $byte3,
						 'crc'   => $byte1.$byte2,
						 'bin0'  => decbin(hexdec($byte0)),
						 'bin3'  => substr('000000000000'.decbin(hexdec($byte3)),-8),			 
						 'payload' => $payload,
						 'isgps' => false,
						 'lat'   => 0,
						 'long'  => 0,
						 'pir'   => 0,
						 'var'   => '', // reserved
						);
							
		if  ((( Payload::getBit($result['bin0'], 1, 2) == '00' ) && (  Payload::getBit($result['bin0'], 3, 1) == '0' )) ||
			  ( Payload::getBit($result['bin0'], 1, 2) == '01' ))			
		{
			// system message	
			$result['issys'] = true;
			
			$result['lat'  ]   = Payload::getLatitude( $payload );
			$result['long' ]   = Payload::getLongitude( $payload );	
			if (($result['lat'] <> 0) && ($result['long'] <> 0)) {
				$result['isgps' ] = true;
			}
		}
		else {
			if ( Payload::getBit($result['bin0'], 1, 2) == '10' ){
			// system message	
				
//				$result['var'] = Payload::getBit($result['bin3'], 0); 

				if ( Payload::getBit($result['bin3'], 1, 2) == '01' ){
					$result['door1'] = 1;	
				}
		
				if ( Payload::getBit($result['bin3'], 3, 2) == '01' ) {
					$result['door2'] = 1;	
				}
				
				if ( Payload::getBit($result['bin3'], 4, 1) == '0' ) {
					$result['pir'] = 1;	
				}
				
/*				
				if (( Payload::getBit($result['bin3'], 0) == '1' ) &&
					( Payload::getBit($result['bin3'], 1) == '0' )){
					$result['door1'] = 1;	
				}
		
				if (( Payload::getBit($result['bin3'], 2) == '1' ) &&
					( Payload::getBit($result['bin3'], 3) == '0' )) {
					$result['door2'] = 1;	
				}
*/				
			}
		}
	
		return $result;
	}
	
	/*
	
	*/
	static public function getBit( $byte, $nbit, $nlen ) {
		return substr($byte, -($nbit + 1), $nlen);
	}	

	/*
	
	*/
	static public function get2Bit( $byte, $nbit ) {
		return substr($byte, -($nbit + 2), 2);
	}	
	
	/*
	  getLatitude
	  @param string payload
	  @return float
	*/
	static public function getLatitude( $payload ) {
		$byte = substr($payload, 4,6);	
	
		$dec = hexdec($byte) * 90 / 8388608;
		if ($dec > 90) {
			$dec = $dec - 180;
		}		
		
		return $dec;
	}
	
	/*
	  getLongitude
	  @param string payload
	  @return float	  
	*/	
	static public function getLongitude( $payload ) {
		$byte = substr($payload, 10,6);	
		$dec = hexdec($byte) * 180 / 8388608;
		if ($dec > 180) {
			$dec = $dec - 360;
		}
		return $dec;
	}	
}